// Lense Flare
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _132
{
    uint _m0;
    uint _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 0, binding = 2, std430) restrict readonly buffer _134_136
{
    _132 _m0[];
} _136;

layout(set = 1, binding = 0, std140) uniform _173_175
{
    vec4 _m0;
    float _m1;
    float _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6[3];
} _175;

layout(set = 0, binding = 1, std140) uniform _196_198
{
    vec4 _m0[64];
} _198;

layout(set = 0, binding = 0, std140) uniform _207_209
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    uint _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26[2];
} _209;

layout(set = 2, binding = 0, std140) uniform _211_213
{
    float _m0;
    float _m1;
    float _m2;
    float _m3;
    uint _m4;
    float _m5[3];
} _213;

layout(set = 0, binding = 3) uniform sampler _201;
layout(set = 2, binding = 1) uniform texture2D _204;
layout(set = 2, binding = 2) uniform texture2D _205;

layout(location = 0, component = 0) in vec4 _103;
layout(location = 2, component = 0) out vec4 _112;
layout(location = 1, component = 0) in vec2 _114;
layout(location = 12, component = 0) in vec2 _121;
layout(location = 3, component = 0) out vec4 _161;
layout(location = 0, component = 0) out vec4 _165;
layout(location = 3, component = 0) in vec4 _166;
uint _23;
uint _25;
uint _27;
uint _29;
uint _31;
uint _33;
uint _35;
uint _36;
uint _38;
uint _39;
uint _41;
uint _43;
uint _45;
uint _47;
uint _49;
uint _51;
uint _53;
uint _55;
uint _57;

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _13(float _12)
{
    return _12 * ((_12 * ((_12 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _19(vec3 _18)
{
    float _78 = _18.x;
    float _82 = _18.y;
    float _87 = _18.z;
    return vec3(_13(_78), _13(_82), _13(_87));
}

void main()
{
    _23 = 2147483648u;
    _25 = 1073741824u;
    _27 = 0u;
    _29 = 268435456u;
    _31 = 536870912u;
    _33 = 805306368u;
    _35 = 1073741824u;
    _36 = 1342177280u;
    _38 = 0u;
    _39 = 16777216u;
    _41 = 33554432u;
    _43 = 50331648u;
    _45 = 67108864u;
    _47 = 83886080u;
    _49 = 100663296u;
    _51 = 117440512u;
    _53 = 134217728u;
    _55 = 150994944u;
    _57 = 167772160u;
    gl_Position = vec4(_103.xy, 0.0, 1.0);
    _112 = vec4(_114.x, _114.y, _112.z, _112.w);
    float _118 = 1.0;
    int _120 = int(_121.x);
    int _126 = int(_121.y);
    _118 = 1.0;
    int _130 = 0;
    int _131 = 0;
    _130 = int(_136._m0[_120]._m0);
    _131 = int(_136._m0[_126]._m0);
    float _149;
    if (_131 > 0)
    {
        float _157 = float(_130) / float(_131);
        _149 = _10(_157);
    }
    else
    {
        _149 = 0.0;
    }
    _118 = _149;
    _161.x = _118;
    vec3 _167 = _166.xyz;
    vec3 _180 = _19(_167) * _175._m0.xyz;
    _165 = vec4(_180.x, _180.y, _180.z, _165.w);
    _165.w = _166.w * _175._m0.w;
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x;// * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
}


