// Hand Colour
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _739
{
    float _m0;
    float _m1;
    float _m2;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 0, std140) uniform _210_212
{
    int _m0;
    uint _m1;
    float _m2[2];
} _212;

layout(set = 0, binding = 2, std430) restrict readonly buffer _259_261
{
    vec4 _m0[];
} _261;

layout(set = 0, binding = 0, std140) uniform _317_319
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    uint _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63[1];
} _319;

layout(set = 2, binding = 0, std140) uniform _507_509
{
    float _m0;
    float _m1;
    float _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7[1];
} _509;

layout(set = 0, binding = 3, std430) restrict readonly buffer _556_558
{
    uint _m0[];
} _558;

layout(set = 0, binding = 4, std430) restrict readonly buffer _643_645
{
    vec4 _m0[];
} _645;

layout(set = 0, binding = 5, std430) restrict readonly buffer _741_743
{
    _739 _m0[];
} _743;

layout(set = 0, binding = 6, std430) restrict readonly buffer _882_884
{
    vec4 _m0[];
} _884;

layout(set = 0, binding = 7, std430) restrict readonly buffer _1145_1147
{
    uint _m0[];
} _1147;

layout(set = 0, binding = 1, std140) uniform _1434_1436
{
    vec4 _m0[64];
} _1436;

layout(push_constant, std430) uniform _488_490
{
    int _m0;
} _490;

layout(location = 0, component = 0) in vec4 _500;
layout(location = 3, component = 0) in vec4 _549;
layout(location = 9, component = 0) in vec4 _573;
layout(location = 2, component = 0) in vec4 _580;
layout(location = 3, component = 0) out vec4 _1391;
layout(location = 2, component = 0) out vec4 _1410;
uint _46;
uint _48;
uint _50;
uint _52;
uint _54;
uint _56;
uint _58;
uint _59;
uint _61;
uint _62;
uint _64;
uint _66;
uint _68;
uint _70;
uint _72;
uint _74;
uint _76;
uint _78;
uint _80;

void _34(out uint _32, uint _33)
{
    _32 = 0u;
}

uint _29(uint _26, uint _27, uint _28)
{
    return (_26 + _27) + _28;
}

void _43(uint _37, uint _38, uint _39, uint _40, uint _41, uint _42)
{
}

mat4 _21(mat3x4 _19, mat4 _20)
{
    vec4 _87 = _20[0];
    vec4 _92 = _20[1];
    vec4 _96 = _20[2];
    vec4 _100 = _20[3];
    vec4 _104 = vec4(_19[0].x, _19[1].x, _19[2].x, 0.0);
    vec4 _114 = vec4(_19[0].y, _19[1].y, _19[2].y, 0.0);
    vec4 _123 = vec4(_19[0].z, _19[1].z, _19[2].z, 0.0);
    vec4 _132 = vec4(_19[0].w, _19[1].w, _19[2].w, 1.0);
    mat4 _142;
    _142[0] = vec4(dot(_87, _104), dot(_87, _114), dot(_87, _123), dot(_87, _132));
    _142[1] = vec4(dot(_92, _104), dot(_92, _114), dot(_92, _123), dot(_92, _132));
    _142[2] = vec4(dot(_96, _104), dot(_96, _114), dot(_96, _123), dot(_96, _132));
    _142[3] = vec4(dot(_100, _104), dot(_100, _114), dot(_100, _123), dot(_100, _132));
    return _142;
}

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

void main()
{
    _46 = 2147483648u;
    _48 = 1073741824u;
    _50 = 0u;
    _52 = 268435456u;
    _54 = 536870912u;
    _56 = 805306368u;
    _58 = 1073741824u;
    _59 = 1342177280u;
    _61 = 0u;
    _62 = 16777216u;
    _64 = 33554432u;
    _66 = 50331648u;
    _68 = 67108864u;
    _70 = 83886080u;
    _72 = 100663296u;
    _74 = 117440512u;
    _76 = 134217728u;
    _78 = 150994944u;
    _80 = 167772160u;
    if (_212._m0 < 0)
    {
        uint _220;
        uint _221 = _220;
        uint _223 = 2u;
        _34(_221, _223);
        _220 = _221;
        uint _229 = _61;
        uint _231 = _56;
        uint _233 = _66 >> uint(24);
        uint _236 = _220;
        uint _238 = 0u;
        uint _239 = _29(_229, _231, _233);
        uint _240 = 1u;
        uint _241 = 792714021u;
        uint _242 = 0u;
        _43(_236, _238, _239, _240, _241, _242);
        uint _249 = _220;
        uint _251 = 1u;
        uint _252 = uint(_212._m0);
        uint _253 = 0u;
        uint _254 = 62u;
        uint _255 = 64u;
        _43(_249, _251, _252, _253, _254, _255);
    }
    vec4 _257 = _261._m0[(_212._m0 * 4) + 0];
    vec4 _270 = _261._m0[(_212._m0 * 4) + 1];
    vec4 _277 = _261._m0[(_212._m0 * 4) + 2];
    mat3x4 _284 = mat3x4(vec4(_257), vec4(_270), vec4(_277));
    vec3 _306 = vec3(_284[0].w, _284[1].w, _284[2].w);
    vec3 _314 = ((_306 - vec3(_319._m50, _319._m51, _319._m52)) * _319._m53) - vec3(_319._m54, _319._m55, _319._m56);
    _284[0].w = _314.x;
    _284[1].w = _314.y;
    _284[2].w = _314.z;
    mat4 _356 = mat4(vec4(_319._m3), vec4(_319._m4), vec4(_319._m5), vec4(_319._m6));
    if ((_212._m1 & 1u) != 0u)
    {
        _356 = mat4(vec4(_319._m7), vec4(_319._m8), vec4(_319._m9), vec4(_319._m10));
    }
    if ((_212._m1 & 2u) != 0u)
    {
        _356 = mat4(vec4(_319._m11), vec4(_319._m12), vec4(_319._m13), vec4(_319._m14));
    }
    mat3x4 _469 = _284;
    mat4 _471 = _356;
    mat4 _468 = _21(_469, _471);
    vec4 _474 = _468[0];
    vec4 _477 = _468[1];
    vec4 _480 = _468[2];
    vec4 _483 = _468[3];
    int _487 = _490._m0;
    vec4 _498;
    if (_487 < 2)
    {
        _498 = vec4(_500.xyz.x, _500.xyz.y, _500.xyz.z, _498.w);
        vec3 _505 = vec3(_509._m0, _509._m1, _509._m2);
        vec3 _517 = vec3(_509._m3, _509._m4, _509._m5);
        vec3 _530 = (_498.xyz * _505) + _517;
        _498 = vec4(_530.x, _530.y, _530.z, _498.w);
        _498.w = 1.0;
    }
    else
    {
        _498 = vec4(0.0, 0.0, 0.0, 1.0);
    }
    if (_487 == 1)
    {
        vec4 _540 = _498;
        vec4 _542 = vec4(0.0);
        vec4 _544 = vec4(0.0);
        vec4 _545 = vec4(0.0);
        uvec4 _548 = uvec4(_549 * 255.0);
        uvec4 _554 = uvec4(uint(float(_558._m0[_212._m0]) + _509._m6)) + _548;
        float _572 = _573.w * 255.100006103515625;
        float _579 = _580.w * 255.100006103515625;
        float _584 = _572;
        float _586 = _579;
        vec4 _588;
        _588.y = _584 - (floor(_584 / 128.0) * 128.0);
        _588.z = floor(_586 / 16.0);
        _588.w = _586 - (_588.z * 16.0);
        _588.y *= 0.00393700785934925079345703125;
        _588.z *= 0.02222222276031970977783203125;
        _588.w *= 0.01666666753590106964111328125;
        _588.x = 1.0 - ((_588.y + _588.z) + _588.w);
        for (uint _633 = 0u; _633 < 4u; _633++)
        {
            _542 += (_645._m0[(_554[_633] * 3u) + 0u] * _588[_633]);
        }
        for (uint _661 = 0u; _661 < 4u; _661++)
        {
            _544 += (_645._m0[(_554[_661] * 3u) + 1u] * _588[_661]);
        }
        for (uint _684 = 0u; _684 < 4u; _684++)
        {
            _545 += (_645._m0[(_554[_684] * 3u) + 2u] * _588[_684]);
        }
        vec4 _707 = _540;
        vec4 _709 = _542;
        _498.x = _12(_707, _709);
        vec4 _713 = _540;
        vec4 _715 = _544;
        _498.y = _12(_713, _715);
        vec4 _719 = _540;
        vec4 _721 = _545;
        _498.z = _12(_719, _721);
        _498.w = 1.0;
    }
    if (_487 > 1)
    {
        uint _730 = uint(_487 - 2);
        uint _734 = uint(gl_VertexIndex);
        _498.x = _743._m0[_734 + _730]._m0;
        _498.y = _743._m0[_734 + _730]._m1;
        _498.z = _743._m0[_734 + _730]._m2;
        _498.w = 1.0;
    }
    vec4 _771 = vec4(_498.xyz, 1.0);
    vec4 _772 = _474;
    vec4 _764;
    _764.x = _12(_771, _772);
    vec4 _782 = vec4(_498.xyz, 1.0);
    vec4 _783 = _477;
    _764.y = _12(_782, _783);
    vec4 _793 = vec4(_498.xyz, 1.0);
    vec4 _794 = _480;
    _764.z = _12(_793, _794);
    vec4 _804 = vec4(_498.xyz, 1.0);
    vec4 _805 = _483;
    _764.w = _12(_804, _805);
    bool _810 = false;
    if (_810 == false)
    {
        vec2 _826 = _764.xy + (_319._m15.xy * _764.w);
        _764 = vec4(_826.x, _826.y, _764.z, _764.w);
    }
    gl_Position = _764;
    int _835 = min(_490._m0, 1);
    if (_212._m0 < 0)
    {
        uint _844;
        uint _845 = _844;
        uint _847 = 2u;
        _34(_845, _847);
        _844 = _845;
        uint _852 = _61;
        uint _854 = _56;
        uint _856 = _66 >> uint(24);
        uint _859 = _844;
        uint _861 = 0u;
        uint _862 = _29(_852, _854, _856);
        uint _863 = 257u;
        uint _864 = 792714021u;
        uint _865 = 0u;
        _43(_859, _861, _862, _863, _864, _865);
        uint _872 = _844;
        uint _874 = 1u;
        uint _875 = uint(_212._m0);
        uint _876 = 0u;
        uint _877 = 67u;
        uint _878 = 69u;
        _43(_872, _874, _875, _876, _877, _878);
    }
    vec4 _880 = _884._m0[(_212._m0 * 4) + 0];
    vec4 _891 = _884._m0[(_212._m0 * 4) + 1];
    vec4 _898 = _884._m0[(_212._m0 * 4) + 2];
    mat3x4 _905 = mat3x4(vec4(_880), vec4(_891), vec4(_898));
    vec3 _925 = vec3(_905[0].w, _905[1].w, _905[2].w);
    vec3 _933 = (_925 - vec3(_319._m57, _319._m58, _319._m59)) - vec3(_319._m60, _319._m61, _319._m62);
    _905[0].w = _933.x;
    _905[1].w = _933.y;
    _905[2].w = _933.z;
    mat4 _966 = mat4(vec4(_319._m16), vec4(_319._m17), vec4(_319._m18), vec4(_319._m19));
    if ((_212._m1 & 1u) != 0u)
    {
        _966 = mat4(vec4(_319._m20), vec4(_319._m21), vec4(_319._m22), vec4(_319._m23));
    }
    if ((_212._m1 & 2u) != 0u)
    {
        _966 = mat4(vec4(_319._m24), vec4(_319._m25), vec4(_319._m26), vec4(_319._m27));
    }
    mat3x4 _1078 = _905;
    mat4 _1080 = _966;
    mat4 _1077 = _21(_1078, _1080);
    vec4 _1083 = _1077[0];
    vec4 _1086 = _1077[1];
    vec4 _1089 = _1077[2];
    vec4 _1092 = _1077[3];
    vec4 _1099;
    if (_835 < 2)
    {
        _1099 = vec4(_500.xyz.x, _500.xyz.y, _500.xyz.z, _1099.w);
        vec3 _1104 = vec3(_509._m0, _509._m1, _509._m2);
        vec3 _1112 = vec3(_509._m3, _509._m4, _509._m5);
        vec3 _1125 = (_1099.xyz * _1104) + _1112;
        _1099 = vec4(_1125.x, _1125.y, _1125.z, _1099.w);
        _1099.w = 1.0;
    }
    else
    {
        _1099 = vec4(0.0, 0.0, 0.0, 1.0);
    }
    if (_835 == 1)
    {
        vec4 _1134 = _1099;
        vec4 _1136 = vec4(0.0);
        vec4 _1137 = vec4(0.0);
        vec4 _1138 = vec4(0.0);
        uvec4 _1139 = uvec4(_549 * 255.0);
        uvec4 _1143 = uvec4(uint(float(_1147._m0[_212._m0]) + _509._m6)) + _1139;
        float _1160 = _573.w * 255.100006103515625;
        float _1164 = _580.w * 255.100006103515625;
        float _1168 = _1160;
        float _1170 = _1164;
        vec4 _1172;
        _1172.y = _1168 - (floor(_1168 / 128.0) * 128.0);
        _1172.z = floor(_1170 / 16.0);
        _1172.w = _1170 - (_1172.z * 16.0);
        _1172.y *= 0.00393700785934925079345703125;
        _1172.z *= 0.02222222276031970977783203125;
        _1172.w *= 0.01666666753590106964111328125;
        _1172.x = 1.0 - ((_1172.y + _1172.z) + _1172.w);
        for (uint _1212 = 0u; _1212 < 4u; _1212++)
        {
            _1136 += (_645._m0[(_1143[_1212] * 3u) + 0u] * _1172[_1212]);
        }
        for (uint _1235 = 0u; _1235 < 4u; _1235++)
        {
            _1137 += (_645._m0[(_1143[_1235] * 3u) + 1u] * _1172[_1235]);
        }
        for (uint _1258 = 0u; _1258 < 4u; _1258++)
        {
            _1138 += (_645._m0[(_1143[_1258] * 3u) + 2u] * _1172[_1258]);
        }
        vec4 _1281 = _1134;
        vec4 _1283 = _1136;
        _1099.x = _12(_1281, _1283);
        vec4 _1287 = _1134;
        vec4 _1289 = _1137;
        _1099.y = _12(_1287, _1289);
        vec4 _1293 = _1134;
        vec4 _1295 = _1138;
        _1099.z = _12(_1293, _1295);
        _1099.w = 1.0;
    }
    if (_835 > 1)
    {
        uint _1304 = uint(_835 - 2);
        uint _1308 = uint(gl_VertexIndex);
        _1099.x = _743._m0[_1308 + _1304]._m0;
        _1099.y = _743._m0[_1308 + _1304]._m1;
        _1099.z = _743._m0[_1308 + _1304]._m2;
        _1099.w = 1.0;
    }
    vec4 _1337 = vec4(_1099.xyz, 1.0);
    vec4 _1338 = _1083;
    vec4 _1330;
    _1330.x = _12(_1337, _1338);
    vec4 _1348 = vec4(_1099.xyz, 1.0);
    vec4 _1349 = _1086;
    _1330.y = _12(_1348, _1349);
    vec4 _1359 = vec4(_1099.xyz, 1.0);
    vec4 _1360 = _1089;
    _1330.z = _12(_1359, _1360);
    vec4 _1370 = vec4(_1099.xyz, 1.0);
    vec4 _1371 = _1092;
    _1330.w = _12(_1370, _1371);
    bool _1375 = false;
    if (_1375 == false)
    {
        vec2 _1388 = _1330.xy + (_319._m15.xy * _1330.w);
        _1330 = vec4(_1388.x, _1388.y, _1330.z, _1330.w);
    }
    _1391 = _1330;
    bool _1393 = false;
    if (_1393 == false)
    {
        vec2 _1407 = _1391.xy - (_319._m15.xy * _1391.w);
        _1391 = vec4(_1407.x, _1407.y, _1391.z, _1391.w);
    }
    _1410 = gl_Position;
    bool _1413 = false;
    if (_1413 == false)
    {
        vec2 _1426 = _1410.xy - (_319._m15.xy * _1410.w);
        _1410 = vec4(_1426.x, _1426.y, _1410.z, _1410.w);
    }
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > 1.8)
gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.z) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


