// More shdows
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_KHR_shader_subgroup_vote : require

struct _120
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    float _m5;
};

struct _129
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _3670
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _4616
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 50, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _805_807
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    uint _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    uint _m61;
    float _m62[2];
} _807;

layout(set = 2, binding = 0, std140) uniform _1136_1138
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    float _m22;
    uint _m23;
    uint _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    uint _m29;
    float _m30;
    uint _m31;
    uint _m32;
    float _m33;
    uint _m34;
    uint _m35;
    uint _m36;
    uint _m37;
    uint _m38;
    float _m39;
    uint _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    uint _m61;
    uint _m62;
    uint _m63;
    int _m64;
    uint _m65;
    float _m66[3];
} _1138;

layout(set = 1, binding = 0, std140) uniform _1148_1150
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    uint _m42;
    uint _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    int _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    uint _m68;
} _1150;

layout(set = 3, binding = 0, std140) uniform _1190_1192
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _1192;

layout(set = 0, binding = 30, std430) restrict readonly buffer _3576_3578
{
    uint _m0[];
} _3578;

layout(set = 0, binding = 31, std140) uniform _3675_3677
{
    vec4 _m0[4096];
} _3677;

layout(set = 0, binding = 32, std140) uniform _3751_3753
{
    vec4 _m0[4096];
} _3753;

layout(set = 0, binding = 34, std430) restrict readonly buffer _4040_4042
{
    uint _m0[];
} _4042;

layout(set = 0, binding = 35, std140) uniform _4621_4623
{
    vec4 _m0[4095];
} _4623;

layout(set = 0, binding = 1, std140) uniform _6450_6452
{
    vec4 _m0[64];
} _6452;

layout(push_constant, std430) uniform _6446_6448
{
    int _m0;
    int _m1;
    int _m2;
} _6448;

layout(set = 3, binding = 1) uniform texture2D _1234[5];
layout(set = 0, binding = 12) uniform sampler _1242;
layout(set = 3, binding = 3) uniform texture2D _1260[5];
layout(set = 0, binding = 13) uniform sampler _1265;
layout(set = 3, binding = 2) uniform texture2D _1272[5];
layout(set = 0, binding = 14) uniform sampler _1277;
layout(set = 3, binding = 4) uniform texture2D _1294[5];
layout(set = 0, binding = 15) uniform sampler _1299;
layout(set = 3, binding = 5) uniform texture2D _1306[5];
layout(set = 0, binding = 16) uniform sampler _1311;
layout(set = 3, binding = 7) uniform texture2D _1318[5];
layout(set = 0, binding = 17) uniform sampler _1323;
layout(set = 3, binding = 8) uniform texture2D _1330[5];
layout(set = 0, binding = 18) uniform sampler _1335;
layout(set = 4, binding = 0) uniform texture2D _1419[34816];
layout(set = 0, binding = 19) uniform sampler _1424;
layout(set = 3, binding = 6) uniform texture2D _1956[5];
layout(set = 0, binding = 20) uniform sampler _1961;
layout(set = 0, binding = 21) uniform TEXTURE_2D _2466;
layout(set = 0, binding = 22) uniform TEXTURE_2D _2582;
layout(set = 0, binding = 23) uniform TEXTURE_2D _2613;
layout(set = 0, binding = 24) uniform TEXTURE_2D _2702;
layout(set = 0, binding = 25) uniform TEXTURE_2D _2735;
layout(set = 0, binding = 26) uniform TEXTURE_2D _2920;
layout(set = 0, binding = 27) uniform sampler _2922;
layout(set = 0, binding = 28) uniform TEXTURE_2D _3157;
layout(set = 0, binding = 29) uniform sampler _3159;
layout(set = 0, binding = 33) uniform textureCubeArray _4006;
layout(set = 0, binding = 10) uniform sampler _4008;
layout(set = 0, binding = 36) uniform texture2D _4944;
layout(set = 0, binding = 37) uniform samplerShadow _4946;
layout(set = 0, binding = 38) uniform TEXTURE_2D _5365;
layout(set = 0, binding = 39) uniform sampler _5367;
layout(set = 0, binding = 40) uniform TEXTURE_2D _5658;
layout(set = 0, binding = 41) uniform TEXTURE_2D _6341;
layout(set = 0, binding = 7) uniform texture3D _6455;
layout(set = 0, binding = 8) uniform sampler _6456;
layout(set = 0, binding = 9) uniform texture3D _6457;

layout(location = 17, component = 3) in float _1017;
layout(location = 18, component = 0) in float _1019;
layout(location = 18, component = 1) in float _1024;
layout(location = 18, component = 2) in float _1026;
layout(location = 18, component = 3) in float _1028;
layout(location = 19, component = 0) in float _1056;
layout(location = 19, component = 1) in float _1058;
layout(location = 19, component = 2) in float _1060;
layout(location = 19, component = 3) in float _1064;
layout(location = 20, component = 0) in float _1066;
layout(location = 20, component = 1) in float _1068;
layout(location = 20, component = 2) in float _1080;
layout(location = 10, component = 0) in vec4 _1105;
layout(location = 11, component = 0) in vec4 _1108;
layout(location = 12, component = 0) in vec4 _1111;
layout(location = 21, component = 1) in float _2089;
layout(location = 17, component = 2) in float _2318;
layout(location = 23, component = 0) in float _2554;
layout(location = 22, component = 3) in float _2579;
layout(location = 21, component = 3) in float _5599;
layout(location = 22, component = 0) in float _5602;
layout(location = 22, component = 1) in float _5605;
layout(location = 22, component = 2) in float _5608;
layout(location = 21, component = 2) in float _6039;
layout(location = 17, component = 1) in float _6088;
layout(location = 0, component = 0) out vec4 _6260;
layout(location = 1, component = 0) out vec4 _6274;
layout(location = 2, component = 0) out vec4 _6301;
uint _179;
uint _181;
uint _183;
uint _185;
uint _187;
uint _189;
uint _191;
uint _192;
uint _194;
uint _195;
uint _197;
uint _199;
uint _201;
uint _203;
uint _205;
uint _207;
uint _209;
uint _211;
uint _213;

_129 _131()
{
    _129 _699;
    _699._m0 = vec3(0.0);
    _699._m2 = vec3(0.0);
    _699._m3 = 0.0;
    _699._m4 = 0u;
    _699._m5 = 0.0;
    _699._m6 = vec3(0.0);
    _699._m7 = vec3(0.0, 0.0, 1.0);
    _699._m8 = vec3(0.0, 0.0, 1.0);
    _699._m1 = vec3(0.0);
    _699._m9 = 1.0;
    _699._m10 = 1.0;
    _699._m14 = vec3(0.0);
    _699._m15 = vec3(0.0);
    _699._m16 = vec4(0.0);
    _699._m17 = vec4(0.0);
    _699._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _699._m19 = vec3(0.0);
    _699._m20 = vec3(0.0);
    _699._m21 = vec3(0.0);
    _699._m22 = vec3(0.0);
    _699._m23 = vec3(0.0);
    _699._m24 = vec3(0.0);
    _699._m25 = 1.0;
    _699._m26 = uvec4(0u);
    _699._m27 = uvec4(0u);
    _699._m28 = uvec4(0u);
    _699._m29 = vec4(0.0);
    _699._m30 = vec4(0.0);
    _699._m31 = vec4(0.0);
    _699._m32 = vec4(0.0);
    _699._m33 = uvec2(0u);
    _699._m34 = vec2(0.0);
    _699._m35 = 0.0;
    _699._m36 = -1;
    _699._m37 = 0;
    _699._m38 = vec2(0.0);
    _699._m39 = 1.0;
    _699._m41 = -1;
    _699._m45 = 1.0;
    _699._m11 = 1.0;
    _699._m12 = 0u;
    _699._m13 = uvec3(0u);
    _699._m40 = vec3(0.0);
    _699._m46 = 0.0;
    _699._m47 = 1.0;
    return _699;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

_120 _122()
{
    _120 _687;
    _687._m0 = vec4(0.0);
    _687._m1 = vec4(0.0);
    _687._m2 = vec4(0.0);
    _687._m3 = vec4(0.0);
    _687._m4 = vec4(0.0);
    _687._m5 = 0.0;
    return _687;
}

vec2 _143(vec2 _142)
{
    return ((_142 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _148(inout vec2 _146, bool _147)
{
    vec2 _839 = _146;
    _146 = _143(_839);
    float _859 = (1.0 - (_146.x * _146.x)) - (_146.y * _146.y);
    vec3 _842 = vec3(_146.x, _146.y, sqrt(_10(_859)));
    if (_147 == false)
    {
        _842.z = -_842.z;
    }
    return _842;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

uint _87(inout vec4 _86)
{
    vec4 _418 = _86;
    _86 = _22(_418);
    return packUnorm4x8(_86.wzyx);
}

float _27(vec3 _25, vec3 _26)
{
    return dot(_25, _26);
}

vec4 _92(uint _91)
{
    return unpackUnorm4x8(_91).wzyx;
}

vec3 _69(mat3 _67, vec3 _68)
{
    return _67 * _68;
}

vec3 _153(vec3 _151, mat3 _152)
{
    mat3 _875 = _152;
    vec3 _877 = _151;
    return normalize(_69(_875, _877));
}

vec3 _159(vec2 _156, mat3 _157, bool _158)
{
    vec2 _884 = _156;
    bool _886 = _158;
    vec3 _888 = _148(_884, _886);
    vec3 _883 = _888;
    vec3 _889 = _883;
    mat3 _891 = _157;
    return _153(_889, _891);
}

float _138(inout float _136, bool _137)
{
    if (_137)
    {
        _136 += (float(_136 < _807._m24) * _807._m25);
    }
    float _820 = _136;
    return _807._m0.w / (_10(_820) + _807._m0.z);
}

uint _32(float _31)
{
    return floatBitsToUint(_31);
}

float _72(float _71)
{
    return exp2(_71);
}

vec3 _118(float _115, float _116, vec3 _117)
{
    float _638 = 0.0949999988079071044921875 + (_116 * (0.60000002384185791015625 + (4.190000057220458984375 * _116)));
    float _648 = _115 + 0.02500000037252902984619140625;
    float _652 = (9.5 * _116) * _115;
    float _666 = 1.0 - (14.0 * _115);
    float _658 = (_638 * _648) * _72(_666);
    float _673 = -_652;
    float _669 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _72(_673)));
    return mix(vec3(_658), vec3(_669), _117);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec3 _52(vec3 _51)
{
    return _51 * _51;
}

float _55(float _54)
{
    return _54 * _54;
}

uint _49(float _46, float _47, float _48)
{
    bool _260 = abs(_48) >= abs(_46);
    bool _268;
    if (_260)
    {
        _268 = abs(_48) >= abs(_47);
    }
    else
    {
        _268 = _260;
    }
    if (_268)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

vec4 _62(vec3 _60, mat4 _61)
{
    return vec4((_60.x * _61[0].x) + ((_60.y * _61[0].y) + ((_60.z * _61[0].z) + _61[0].w)), (_60.x * _61[1].x) + ((_60.y * _61[1].y) + ((_60.z * _61[1].z) + _61[1].w)), (_60.x * _61[2].x) + ((_60.y * _61[2].y) + ((_60.z * _61[2].z) + _61[2].w)), (_60.x * _61[3].x) + ((_60.y * _61[3].y) + ((_60.z * _61[3].z) + _61[3].w)));
}

float _165(uvec2 _163, uint _164)
{
    uvec2 _896 = _163 & uvec2(3u);
    return float(((((2068378560u * (1u - (_896.x >> uint(1)))) + (1500172770u * (_896.x >> uint(1)))) >> ((_896.y + ((_896.x & 1u) << uint(2))) << uint(2))) + _164) & 15u) / 16.0;
}

float _77(float _75, float _76)
{
    return pow(_75, _76);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _97(vec3 _95, float _96)
{
    float _436 = dot(_95, vec3(16.666500091552734375));
    float _431 = _10(_436);
    float _445 = 1.0 - _96;
    float _448 = _10(_445);
    float _449 = 5.0;
    vec3 _453 = _95 + ((vec3(_431) - _95) * _77(_448, _449));
    return _16(_453);
}

vec3 _105(vec3 _100, vec3 _101, vec3 _102, vec3 _103, float _104)
{
    float _461 = dot(_100, _101);
    float _457 = _10(_461);
    vec3 _463 = normalize(_101 + _102);
    float _472 = dot(_100, _463);
    float _468 = _10(_472);
    float _478 = dot(_102, _463);
    float _474 = _10(_478);
    vec3 _481 = _103;
    float _483 = _474;
    vec3 _480 = _97(_481, _483);
    float _490 = dot(_100, _102);
    float _486 = _10(_490);
    float _492 = 1.0 - (_104 * 0.800000011920928955078125);
    _492 *= _492;
    _492 *= _492;
    float _503 = _492 * _492;
    float _507 = ((_468 * _468) * (_503 - 1.0)) + 1.0;
    _507 = _503 / ((_507 * _507) + 9.9999999392252902907785028219223e-09);
    float _522 = (_457 * (1.0 - _492)) + _492;
    float _529 = (_486 * (1.0 - _492)) + _492;
    _507 /= (((4.0 * _522) * _529) + 9.9999999392252902907785028219223e-09);
    return _480 * _507;
}

vec3 _112(vec3 _107, vec3 _108, vec3 _109, vec3 _110, float _111)
{
    float _553 = dot(_107, _108);
    float _549 = _10(_553);
    vec3 _555 = normalize(_108 + _109);
    float _564 = dot(_107, _555);
    float _560 = _10(_564);
    float _570 = dot(_109, _555);
    float _566 = _10(_570);
    vec3 _573 = _110;
    float _575 = _566;
    vec3 _572 = _97(_573, _575);
    float _582 = dot(_107, _109);
    float _578 = _10(_582);
    float _584 = 1.0 - (_111 * 0.800000011920928955078125);
    float _588 = _584 * _584;
    float _592 = _560 * _560;
    float _596 = 1.0 - _592;
    float _599 = _596 * _596;
    float _603 = (_599 + (4.0 * exp((-_592) / (_596 * _588)))) / ((1.0 + (4.0 * _588)) * _599);
    float _620 = (4.0 * ((_578 + _549) - (_578 * _549))) + 9.9999999392252902907785028219223e-09;
    return (_572 * _603) / vec3(_620);
}

vec2 _168(vec2 _167)
{
    return (vec2(1.0) - abs(_167.yx)) * vec2((_167.x >= 0.0) ? 1.0 : (-1.0), (_167.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _173(inout vec3 _171, bool _172)
{
    _171 /= vec3((abs(_171.x) + abs(_171.y)) + abs(_171.z));
    vec2 _965;
    if (_171.z >= 0.0)
    {
        _965 = _171.xy;
    }
    else
    {
        vec2 _971 = _171.xy;
        _965 = _168(_971);
    }
    _171 = vec3(_965.x, _965.y, _171.z);
    if (_172)
    {
        vec2 _986 = (_171.xy * 0.5) + vec2(0.5);
        _171 = vec3(_986.x, _986.y, _171.z);
    }
    return _171.xy;
}

float _80(float _79)
{
    return sqrt(_79);
}

float _83(float _82)
{
    return sqrt(_82);
}

float _176(float _175)
{
    float _996 = abs(_175);
    float _993 = _83(_996);
    float _1000;
    if (_175 > 0.0)
    {
        _1000 = _993;
    }
    else
    {
        _1000 = -_993;
    }
    return (_1000 * 0.5) + 0.5;
}

void main()
{
    _179 = 2147483648u;
    _181 = 1073741824u;
    _183 = 0u;
    _185 = 268435456u;
    _187 = 536870912u;
    _189 = 805306368u;
    _191 = 1073741824u;
    _192 = 1342177280u;
    _194 = 0u;
    _195 = 16777216u;
    _197 = 33554432u;
    _199 = 50331648u;
    _201 = 67108864u;
    _203 = 83886080u;
    _205 = 100663296u;
    _207 = 117440512u;
    _209 = 134217728u;
    _211 = 150994944u;
    _213 = 167772160u;
    float _1012 = 0.0;
    float _1013 = 1.0;
    _129 _1014 = _131();
    _1014._m16 = vec4(0.0, 0.0, _1017, _1019);
    vec3 _1023 = vec3(_1024, _1026, _1028);
    _1014._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _1014._m15 = vec3(_807._m35, _807._m36, _807._m37) + _1023;
    vec3 _1054 = vec3(0.0);
    vec3 _1055 = vec3(0.0);
    _1054 = normalize(vec3(_1056, _1058, _1060));
    _1055 = normalize(vec3(_1064, _1066, _1068));
    vec3 _1072 = _1054;
    vec3 _1074 = _1055;
    vec3 _1076 = normalize(cross(_1072, _1074) * _1080);
    _1014._m18 = mat3(vec3(_1074), vec3(_1076), vec3(_1072));
    _1014._m14 = normalize(-_1023);
    _1014._m29 = _1105;
    _1014._m30 = _1108;
    _1014._m31 = _1111;
    uint _1114 = 0u;
    vec4 _1115 = vec4(0.0);
    vec4 _1116 = vec4(0.0);
    vec4 _1117 = vec4(0.0);
    vec4 _1118 = vec4(0.0);
    vec4 _1119 = vec4(0.0);
    float _1120 = 0.0;
    uvec2 _1121 = uvec2(0u, 65535u);
    vec2 _1124 = _1014._m16.zw;
    vec2 _1128 = _1124;
    vec2 _1130 = _1124;
    float _1132 = 0.0009765625;
    vec3 _1145;
    if ((_1138._m65 & 1u) != 0u)
    {
        _1145 = vec3(_1150._m46, _1150._m47, _1150._m48);
    }
    else
    {
        _1145 = vec3(1.0);
    }
    vec3 _1134 = _1145;
    float _1162 = 1.0;
    float _1163 = _1150._m49;
    bool _1167 = _1163 > 0.0;
    float _1170 = 1.0;
    uint _1171 = _1121.x;
    uint _1174 = _1171 & 7u;
    uint _1178 = _1174;
    uint _1180 = _1178;
    float _1182 = 0.0;
    vec2 _1183 = _1128;
    _1183.x *= _1192._m1[_1180].w;
    _1183.y *= _1192._m2[_1180].x;
    _1183.x += (_807._m53 * _1192._m2[_1180].y);
    _1183.y += (_807._m53 * _1192._m2[_1180].z);
    vec2 _1228 = _1183;
    uint _1236 = _1180;
    vec3 _1230 = (texture(sampler2D(_1234[nonuniformEXT(_1236)], _1242), _1228).xyz * vec3(_1192._m0[_1180].x)) + vec3(_1192._m0[_1180].y);
    uint _1262 = _1180;
    vec2 _1259 = texture(sampler2D(_1260[nonuniformEXT(_1262)], _1265), _1228).xy;
    uint _1274 = _1180;
    vec3 _1271 = (texture(sampler2D(_1272[nonuniformEXT(_1274)], _1277), _1228).xyz * vec3(_1192._m0[_1180].z)) + vec3(_1192._m0[_1180].w);
    uint _1296 = _1180;
    float _1293 = texture(sampler2D(_1294[nonuniformEXT(_1296)], _1299), _1228).x;
    uint _1308 = _1180;
    float _1305 = texture(sampler2D(_1306[nonuniformEXT(_1308)], _1311), _1228).x;
    uint _1320 = _1180;
    vec3 _1317 = texture(sampler2D(_1318[nonuniformEXT(_1320)], _1323), _1228).xyz;
    uint _1332 = _1180;
    float _1329 = texture(sampler2D(_1330[nonuniformEXT(_1332)], _1335), _1228).x;
    _1115 = vec4(_1230.x, _1230.y, _1230.z, _1115.w);
    _1115.w = 0.0;
    _1116 = vec4(_1271.x, _1271.y, _1271.z, _1116.w);
    _1116.w = _1305;
    _1117 = vec4(_1259.x, _1259.y, _1117.z, _1117.w);
    _1118.x = 0.0;
    _1118.y = _1182;
    _1118.z = _1305;
    _1118.w = _1293;
    _1120 = _1329;
    _1170 = _1192._m1[_1180].x;
    vec3 _1370 = _1317 * _1192._m3[_1180].xyz;
    _1119 = vec4(_1370.x, _1370.y, _1370.z, _1119.w);
    float _1373 = _1167 ? _1163 : _1170;
    vec3 _1382 = _1119.xyz * vec3(_1373);
    _1119 = vec4(_1382.x, _1382.y, _1382.z, _1119.w);
    vec2 _1385 = vec2(0.0);
    _120 _1386;
    _1386._m0 = _1115;
    _1386._m1 = _1116;
    _1386._m2 = _1118;
    _1386._m3 = _1117;
    _1386._m4 = _1119;
    _1386._m5 = _1120;
    _1385 = _1386._m3.xy;
    _1386._m3 = vec4(vec2(0.5).x, vec2(0.5).y, _1386._m3.z, _1386._m3.w);
    bool _1406 = (_1138._m65 & 4u) != 0u;
    if (_1406)
    {
        vec4 _1415 = vec4(0.0);
        _1415 = texture(sampler2D(_1419[_1138._m40], _1424), _1128);
        _1415 *= _1138._m7;
        _1415 = min(_1415, vec4(1.0));
        float _1436 = (_1120 - 0.4980392158031463623046875) * _1138._m17;
        for (int _1443 = 0; _1443 < 4; _1443++)
        {
            float _1451 = _1415[_1443];
            if (!(_1451 == 0.0))
            {
                float _1459 = 0.0;
                vec2 _1460 = vec2(_1138._m3[_1443]);
                uint _1465 = uint(_1443 + 1);
                uint _1469 = _1465 & 7u;
                uint _1472 = _1469;
                uint _1474 = _1472;
                uint _1477 = _1474;
                _1459 = texture(sampler2D(_1330[nonuniformEXT(_1477)], _1335), _1124 * _1460).x;
                _1459 -= 0.4980392158031463623046875;
                _1459 *= _1138._m6[_1443];
                float _1494 = (_1436 + 1.0) - _1451;
                float _1499 = (_1459 + 0.0) + _1451;
                float _1504 = _1499 - _1494;
                float _1508 = (clamp(_1504 / _1138._m10[_1443], -1.0, 1.0) / 2.0) + 0.5;
                float _1518 = 0.100000001490116119384765625;
                float _1520 = abs(0.5 - _1451);
                float _1531 = (_1520 - (0.5 - _1518)) / _1518;
                float _1524 = _10(_1531);
                float _1533 = 0.0;
                if ((_1451 < _1518) && (_1508 > _1451))
                {
                    _1533 = mix(_1508, _1451, _1524);
                }
                else
                {
                    if ((_1451 > (1.0 - _1518)) && (_1508 < _1451))
                    {
                        _1533 = mix(_1508, _1451, _1524);
                    }
                    else
                    {
                        _1533 = _1508;
                    }
                }
                float _1564 = _1138._m4[_1443];
                float _1568 = _1138._m8[_1443];
                float _1572 = _1138._m11[_1443];
                float _1576 = _1138._m9[_1443];
                float _1580 = _1138._m5[_1443];
                _120 _1584 = _122();
                float _1586 = _1150._m49;
                bool _1589 = _1586 > 0.0;
                float _1592 = 1.0;
                uint _1593 = uint(_1443 + 1);
                uint _1597 = _1593 & 7u;
                uint _1600 = _1597;
                uint _1602 = _1600;
                float _1604 = 0.0;
                vec2 _1605 = _1124 * _1460;
                _1605.x *= _1192._m1[_1602].w;
                _1605.y *= _1192._m2[_1602].x;
                _1605.x += (_807._m53 * _1192._m2[_1602].y);
                _1605.y += (_807._m53 * _1192._m2[_1602].z);
                vec2 _1643 = _1605;
                uint _1647 = _1602;
                vec3 _1645 = (texture(sampler2D(_1234[nonuniformEXT(_1647)], _1242), _1643).xyz * vec3(_1192._m0[_1602].x)) + vec3(_1192._m0[_1602].y);
                uint _1667 = _1602;
                vec2 _1665 = texture(sampler2D(_1260[nonuniformEXT(_1667)], _1265), _1643).xy;
                uint _1677 = _1602;
                vec3 _1675 = (texture(sampler2D(_1272[nonuniformEXT(_1677)], _1277), _1643).xyz * vec3(_1192._m0[_1602].z)) + vec3(_1192._m0[_1602].w);
                uint _1697 = _1602;
                float _1695 = texture(sampler2D(_1294[nonuniformEXT(_1697)], _1299), _1643).x;
                uint _1707 = _1602;
                float _1705 = texture(sampler2D(_1306[nonuniformEXT(_1707)], _1311), _1643).x;
                uint _1717 = _1602;
                vec3 _1715 = texture(sampler2D(_1318[nonuniformEXT(_1717)], _1323), _1643).xyz;
                uint _1727 = _1602;
                float _1725 = texture(sampler2D(_1330[nonuniformEXT(_1727)], _1335), _1643).x;
                _1584._m0 = vec4(_1645.x, _1645.y, _1645.z, _1584._m0.w);
                _1584._m0.w = 0.0;
                _1584._m1 = vec4(_1675.x, _1675.y, _1675.z, _1584._m1.w);
                _1584._m1.w = _1705;
                _1584._m3 = vec4(_1665.x, _1665.y, _1584._m3.z, _1584._m3.w);
                _1584._m2.x = 0.0;
                _1584._m2.y = _1604;
                _1584._m2.z = _1705;
                _1584._m2.w = _1695;
                _1584._m5 = _1725;
                _1592 = _1192._m1[_1602].x;
                vec3 _1767 = _1715 * _1192._m3[_1602].xyz;
                _1584._m4 = vec4(_1767.x, _1767.y, _1767.z, _1584._m4.w);
                float _1771 = _1589 ? _1586 : _1592;
                vec3 _1781 = _1584._m4.xyz * vec3(_1771);
                _1584._m4 = vec4(_1781.x, _1781.y, _1781.z, _1584._m4.w);
                _1386._m0 = mix(_1386._m0, _1584._m0, vec4(_1533 * _1564));
                _1386._m1 = mix(_1386._m1, _1584._m1, vec4(_1533 * _1572));
                _1386._m2.w = mix(_1386._m2.w, _1584._m2.w, _1533 * _1576);
                vec3 _1822 = mix(_1386._m2.xyz, _1584._m2.xyz, vec3(_1533));
                _1386._m2 = vec4(_1822.x, _1822.y, _1822.z, _1386._m2.w);
                _1386._m3 = mix(_1386._m3, _1584._m3, vec4(_1533 * _1568));
                _1386._m4 = mix(_1386._m4, _1584._m4, vec4(_1533 * _1580));
                _1386._m5 = mix(_1386._m5, _1584._m5, _1533);
            }
        }
    }
    _1115 = _1386._m0;
    _1116 = _1386._m1;
    _1118.w = _1386._m2.w;
    _1117 = _1386._m3;
    _1119 = _1386._m4;
    _1120 = _1386._m5;
    vec2 _1870 = _1385;
    bool _1872 = true;
    vec3 _1873 = _148(_1870, _1872);
    vec3 _1868 = _1873;
    vec2 _1875 = _1117.xy;
    bool _1878 = true;
    vec3 _1879 = _148(_1875, _1878);
    vec3 _1874 = _1879;
    vec3 _1880 = _1868 + vec3(0.0, 0.0, 1.0);
    vec3 _1883 = vec3(-_1874.xy, _1874.z);
    vec3 _1892 = (_1880 * dot(_1880, _1883)) - (_1883 * _1880.z);
    vec3 _1904 = normalize(_1892);
    _1117 = vec4(_1904.x, _1904.y, _1904.z, _1117.w);
    vec3 _1909 = _1117.xyz + vec3(1.0);
    _1117 = vec4(_1909.x, _1909.y, _1909.z, _1117.w);
    vec3 _1914 = _1117.xyz * 0.5;
    _1117 = vec4(_1914.x, _1914.y, _1914.z, _1117.w);
    _1014._m22 = _1119.xyz * _1134;
    vec3 _1922 = vec3(0.0);
    vec3 _1923 = vec3(0.0);
    float _1924 = 0.0;
    uint _1925 = 0u;
    uint _1926 = _1925 & 7u;
    uint _1929 = _1926;
    uint _1931 = _1929;
    vec4 _1933 = vec4(_1124, 0.0, _1138._m42);
    uint _1942 = _1931;
    vec2 _1952 = texture(sampler2D(_1260[nonuniformEXT(_1942)], _1265), _1933.xy, _1933.w).xy;
    _1922 = vec3(_1952.x, _1952.y, _1922.z);
    uint _1958 = _1931;
    vec4 _1955 = texture(sampler2D(_1956[nonuniformEXT(_1958)], _1961), _1933.xy, _1933.w);
    _1923 = _1955.xyz;
    _1924 = _1955.w;
    _1014._m8 = _1922;
    float _1980 = _1924 * _1138._m46;
    float _1975 = _10(_1980);
    vec4 _1988 = vec4(_1923, _1975);
    uint _1989 = _87(_1988);
    _1014._m4 = _1989;
    float _1996 = (1.0 - _1975) * _1138._m41;
    _1014._m10 = _10(_1996);
    _1014._m0 = _1115.xyz;
    _1014._m2 = _1116.xyz;
    _1014._m1 = _1119.xyz;
    _1014._m3 = _1118.w;
    _1014._m6 = _1117.xyz;
    _1014._m46 = texture(sampler2D(_1419[_1138._m23], _1424), _1124).x;
    float _2024 = 0.0;
    vec3 _2025 = vec3(0.0);
    bool _2028 = _1138._m12.x < 1.0;
    bool _2036;
    if (!_2028)
    {
        _2036 = _1150._m52 < 1.0;
    }
    else
    {
        _2036 = _2028;
    }
    if (_2036)
    {
        vec4 _2039 = texture(sampler2D(_1419[_1138._m63], _1424), vec2(_1017, _1019) * _1138._m14.xy);
        vec3 _2055 = vec3((_2039.xy * 2.0) - vec2(1.0), 0.0);
        vec3 _2064 = _2055;
        vec3 _2066 = _2055;
        _2055.z = sqrt(1.0 - min(_27(_2064, _2066), 1.0));
        _2055 = normalize(_2055);
        _2055.z *= 1.0;
        _2055.z *= (_2055.z * _2055.z);
        float _2088 = _2089;
        float _2091 = 1.0 - _2088;
        vec4 _2094 = vec4(1.0);
        if (_1138._m60 > 0.0)
        {
            _2094 = texture(sampler2D(_1419[_1138._m61], _1424), vec2(_1017, _1019));
            _2091 = _2094.y;
        }
        float _2119 = 1.0 - (_2091 * _2091);
        float _2114 = _10(_2119);
        float _2121 = _2114 * _2114;
        float _2125 = (_2114 * _2114) * _2114;
        float _2131 = 1.0 - _2114;
        float _2134 = _2114 * _2039.z;
        vec4 _2139 = vec4(0.0);
        _2139 = texture(sampler2D(_1419[_1138._m24], _1424), vec2(_1017, _1019) * _1138._m14.xy);
        if ((_1138._m65 & 2u) != 0u)
        {
            _2134 = ((_2114 * _2114) * _2114) * _2139.z;
        }
        float _2174 = (_2121 * 8.0) - 7.0;
        float _2168 = _10(_2174);
        float _2185 = ((_2134 * (1.0 + _2131)) - (1.0 - _2125)) + _2168;
        _2134 = _10(_2185);
        float _2189 = _2134 * 16.0;
        _2134 = _10(_2189);
        float _2191 = _2134 * _2134;
        float _2195 = _2191 * mix(1.0, 0.25, _2114);
        float _2204 = _2039.z;
        float _2201 = _2055.z * _10(_2204);
        if (((_1138._m65 & 2u) != 0u) == false)
        {
            _1014._m0 = mix(_1014._m0, _1014._m0 * mix(mix(_1138._m0.xyz, vec3(_1138._m18, _1138._m19, _1138._m20), vec3(_2201, _2201, _2201)), _1138._m0.xyz, vec3(_2125 * _2191)), vec3(_2134 * mix(1.0, _2125, _1138._m22)));
            float _2253 = _2191 * _1138._m21;
            _1014._m0 = mix(_1014._m0, mix(_1138._m0.xyz, vec3(_1138._m18, _1138._m19, _1138._m20), vec3(_2114)), vec3((_2253 * _2201) * _2114));
            _2024 = _2039.z;
            _2025 = mix(_1014._m6, mix(_1014._m6, _2039.xyz, vec3(0.1500000059604644775390625)), vec3((_2039.z * _2039.z) * _1150._m66));
            _1014._m2 = mix(_1014._m2, vec3(0.0199999995529651641845703125), vec3(_2191));
            _1014._m3 = mix(_1014._m3, 0.75, _2191);
        }
        float _2317 = _2318;
        if ((_1138._m65 & 2u) != 0u)
        {
            vec2 _2334 = mix(_1014._m6.xy, _2139.xy, vec2(1.0 - _2091));
            _1014._m6 = vec3(_2334.x, _2334.y, _1014._m6.z);
        }
        else
        {
            vec2 _2346 = mix(_1014._m6.xy, _2039.xy, vec2(_2195));
            _1014._m6 = vec3(_2346.x, _2346.y, _1014._m6.z);
            vec2 _2357 = mix(_1014._m6.xy, _2139.xy, vec2(_2317));
            _1014._m6 = vec3(_2357.x, _2357.y, _1014._m6.z);
        }
        vec3 _2361 = mix(vec3(0.00999999977648258209228515625), vec3(0.119999997317790985107421875, 0.10999999940395355224609375, 0.100000001490116119384765625), vec3(_2139.z));
        float _2371 = mix(0.100000001490116119384765625, 0.699999988079071044921875, _2139.z);
        _1014._m0 = mix(_1014._m0, _2361, vec3(_2317));
        _1014._m3 = mix(_1014._m3, _2371, _2317);
        _1014._m2 = mix(_1014._m2, vec3(0.048000000417232513427734375), vec3(_2317));
        if ((_1138._m65 & 2u) != 0u)
        {
            vec3 _2403 = vec3(0.0);
            _1014._m0 = mix(_1014._m0, _2361, vec3(1.0 - _2091));
            _1014._m3 = mix(_1014._m3, _2371, 1.0 - _2091);
            _1014._m2 = mix(_1014._m2, vec3(0.048000000417232513427734375), vec3(1.0 - _2091));
            _1014._m22 = mix(vec3(_2139.z * _2139.z) * vec3(1.0, 0.070000000298023223876953125, 0.0), _1014._m22, vec3(_2091));
            _2403 = (((mix(vec3(mix(mix(_2139.w, _2139.z, 1.0 - _2091), 0.0, _2091)), _1014._m22, vec3(_2091)) * vec3(1.0, 0.070000000298023223876953125, 0.0)) * 25.0) * _1014._m6.x) * _1014._m6.y;
            float _2465 = SAMPLE_TEXTURE(SAMPLER_2D(_2466, _1424), (vec2(_1017, _1019) * vec2(_1138._m1.x)) + vec2(0.0, _807._m53 * _1138._m1.z)).x;
            float _2486 = SAMPLE_TEXTURE(SAMPLER_2D(_2466, _1424), (vec2(_1017, _1019) * vec2(_1138._m1.y)) - vec2(0.0, _807._m53 * _1138._m1.w)).x;
            _2465 *= _2465;
            _2486 *= _2486;
            float _2512 = _2465 * _2486;
            float _2518 = _2512 + 0.119999997317790985107421875;
            _2512 = _10(_2518);
            _1014._m22 += (_2403 * _2512);
        }
    }
    if (_1150._m45 > 0.0)
    {
        uint _2532 = 0u;
        uint _2533 = _2532 & 7u;
        uint _2536 = _2533;
        vec3 _2538 = vec3(_1024, _1026, _1028);
        vec3 _2543 = vec3(_807._m35, _807._m36, _807._m37) + _2538;
        float _2553 = _2554;
        vec2 _2556 = _2543.yz + vec2(_2553);
        vec2 _2562 = _2543.xz + vec2(_2553);
        _2556 *= _1138._m14.zw;
        _2562 *= _1138._m14.zw;
        float _2578 = _2579;
        vec3 _2581 = SAMPLE_TEXTURE(SAMPLER_2D(_2582, _1424), _2556).xyz;
        vec3 _2589 = SAMPLE_TEXTURE(SAMPLER_2D(_2582, _1424), _2562).xyz;
        vec3 _2596 = mix(_2589, _2581, vec3(_2578));
        float _2602 = _1150._m45;
        _1014._m0 = mix(_1014._m0, _2596, vec3(_2602));
        vec3 _2612 = SAMPLE_TEXTURE(SAMPLER_2D(_2613, _1424), _2556).xyw;
        vec3 _2620 = SAMPLE_TEXTURE(SAMPLER_2D(_2613, _1424), _2562).xyw;
        vec3 _2627 = mix(_2620, _2612, vec3(_2578));
        vec2 _2640 = mix(_1014._m6.xy, _2627.xy, vec2(_2602));
        _1014._m6 = vec3(_2640.x, _2640.y, _1014._m6.z);
        _1014._m8 = vec3(_1014._m6.xy.x, _1014._m6.xy.y, _1014._m8.z);
        _1014._m2 = (_1014._m2 * (1.0 - _2602)) + vec3(0.017999999225139617919921875 * _2602);
        _1014._m3 = mix(_1014._m3, 0.699999988079071044921875, _2602);
        _1014._m5 = _1150._m45;
        uint _2670 = _1014._m4;
        vec4 _2669 = _92(_2670);
        vec4 _2692 = vec4(mix(_2669.xyz, vec3(_2627.z) * vec3(0.36000001430511474609375, 0.86000001430511474609375, 1.0), vec3(_2602)), _2669.w);
        uint _2693 = _87(_2692);
        _1014._m4 = _2693;
    }
    if ((_807._m61 & 1u) != 0u)
    {
        vec4 _2701 = TEXTURE_LOD(SAMPLER_2D(_2702, _1424), vec4(_1014._m17.xy * _807._m6.xy, 0.0, 0.0).xy, vec4(_1014._m17.xy * _807._m6.xy, 0.0, 0.0).w);
        if (_2701.w > 0.0)
        {
            vec4 _2734 = SAMPLE_TEXTURE(SAMPLER_2D(_2735, _1424), _1014._m16.zw * _1138._m58);
            float _2748 = _2734.w;
            float _2747 = _10(_2748);
            _1014._m6 = mix(_2025, _2734.xyz, vec3(_2747));
            _1014._m3 = mix(_1014._m3, 0.87999999523162841796875, max(_2024, _2747));
            _1014._m3 = max(_1138._m59, _1014._m3);
            _1014._m0 = mix(_1014._m0, _1014._m0 * _1138._m57, vec3(max(_2024, _2747)));
        }
    }
    uint _2788 = 0u;
    bool _2789 = true;
    vec2 _2790 = _1014._m6.xy;
    bool _2794 = _2789;
    vec3 _2796 = _148(_2790, _2794);
    _1014._m7 = _2796;
    vec2 _2798 = _1014._m6.xy;
    mat3 _2802 = _1014._m18;
    bool _2805 = _2789;
    _1014._m6 = _159(_2798, _2802, _2805);
    vec2 _2809 = _1014._m8.xy;
    mat3 _2813 = _1014._m18;
    bool _2816 = _2789;
    _1014._m8 = _159(_2809, _2813, _2816);
    uvec2 _2820 = uvec2(_1014._m17.xy);
    uint _2825 = _2820.x / 256u;
    uint _2830 = _2820.y / 256u;
    float _2835 = _1014._m17.z;
    bool _2838 = false;
    float _2839 = _138(_2835, _2838);
    float _2834 = _2839;
    float _2840 = log2(max(1.0, _2834 / _807._m7.z)) * _807._m7.w;
    uint _2850 = min(23u, uint(_2840));
    float _2857 = _807._m54;
    float _2863 = _807._m55;
    uint _2855 = (_32(_2857) + ((_2825 + (_32(_2863) * _2830)) * 24u)) + _2850;
    uvec2 _2875 = uvec2(_1014._m17.xy);
    uint _2880 = _2875.x / 32u;
    uint _2885 = _2875.y / 32u;
    float _2893 = _807._m56;
    uint _2889 = _2880 + (_2885 * _32(_2893));
    float _2900 = _1150._m53;
    uint _2899 = _32(_2900);
    float _2904 = _807._m8.x;
    if (_2904 > 0.0)
    {
        vec2 _2911 = _1014._m17.xy * _807._m6.xy;
        vec3 _2919 = (TEXTURE_LOD(SAMPLER_2D(_2920, _2922), vec4(_2911, 0.0, 0.0).xy, vec4(_2911, 0.0, 0.0).w).xyz * 2.0) - vec3(1.0);
        float _2944 = dot(_2919, _1014._m6);
        _1014._m11 = _10(_2944);
        float _2951 = 1.0 - pow(_1014._m11, 0.699999988079071044921875);
        _1014._m11 = _10(_2951);
        _1014._m11 *= _1014._m11;
    }
    _1014._m21 = _1014._m22;
    _1014._m25 = 1.0;
    float _2964 = _807._m9.w;
    bool _2967 = _2964 < 0.0;
    _2964 = abs(_2964);
    vec3 _2972 = _1014._m15;
    float _2990 = (1.0 - (length(_2972 - vec3(_807._m35, _807._m36, _807._m37)) / _2964)) / 0.25;
    float _2975 = _10(_2990);
    if ((!_2967) && (_2975 > 0.0))
    {
        vec3 _2999 = _807._m9.xyz;
        vec3 _3003 = _807._m10.xyz;
        float _3007 = _2972.z - _3003.z;
        float _3013 = _807._m11.w;
        float _3016 = _807._m12.w;
        float _3019 = float(_3016 < 0.0);
        _3016 = abs(_3016) - 1.0;
        bool _3026 = _3007 <= 0.0;
        float _3029 = 3.5 * float(!(_3016 == 0.0));
        float _3038;
        if (!(_3013 == 0.0))
        {
            _3038 = _2999.z;
        }
        else
        {
            _3038 = _3003.z;
        }
        float _3035 = _3038;
        float _3047 = min(_3026 ? 2.0 : 1000.0, abs(_3007));
        float _3054 = max(_2999.x - _2972.x, _2972.x - _3003.x);
        float _3066 = max(_2999.y - _2972.y, _2972.y - _3003.y);
        float _3078 = max(_3054, _3066) - _3047;
        _3078 = max(_3078, _3035 - _2972.z);
        _3078 = max(_3078, _3007 - _3029);
        if (_3078 <= 0.0)
        {
            float _3099 = _3026 ? _3013 : _3016;
            vec2 _3104 = _1014._m18[2].xy;
            float _3108 = length(_3104);
            vec3 _3111 = vec3(_3104, (-1.73205077648162841796875) * _3108);
            _3111 /= vec3(2.0 * _3108);
            vec3 _3124 = _807._m12.xyz;
            vec3 _3128 = mix(_3111, _3124, bvec3(_3026));
            vec2 _3135 = _2972.xy - (_3128.xy * (_3007 / _3128.z));
            float _3146 = (_807._m57 / 100.0) * 16.0;
            vec2 _3152 = _3135 * _3146;
            float _3156 = TEXTURE_LOD(SAMPLER_2D(_3157, _3159), vec4(_3152, 0.0, 0.0).xy, vec4(_3152, 0.0, 0.0).w).x;
            float _3174 = min(8.0, _3003.z - _2999.z);
            float _3186 = (-_3007) / _3174;
            float _3181 = _10(_3186);
            float _3193 = dot(_1014._m6, _3128);
            float _3188 = _10(_3193);
            float _3199 = _3054 / _3047;
            float _3195 = 1.0 - _10(_3199);
            float _3205 = _3066 / _3047;
            _3195 *= (1.0 - _10(_3205));
            _3195 *= _3195;
            float _3221 = min(_3007 / 1.0, 1.0 - (_3007 / _3029));
            float _3213 = _10(_3221);
            _3195 *= max(_3213, _3181);
            _3195 *= _3195;
            _3195 *= _2975;
            float _3234 = _3156 - 1.0;
            float _3237 = float(_3026) * _3019;
            float _3242 = max(0.0, _3156 - 0.85000002384185791015625);
            float _3247 = _3026 ? _3234 : _3242;
            float _3252 = (((1.0 - _3237) * _3188) * _3195) * _3099;
            vec3 _3261 = _1014._m0 + (_1014._m2 * (vec3(1.0) - _1014._m0));
            _1014._m21 += ((_3261 * (_3247 * _3252)) * _807._m11.xyz);
            float _3285 = _3237 * _3195;
            _1014._m25 = 1.0 + (_3285 * (_3156 - 1.0));
        }
    }
    else
    {
        if (_2975 > 0.0)
        {
            _2975 *= _807._m58;
            float _3304 = float(_807._m12.w < 0.0);
            vec3 _3309 = _807._m12.xyz;
            float _3318 = dot(_1014._m6, _3309);
            float _3313 = _10(_3318);
            vec2 _3320 = _2972.xy - (_3309.xy * (_2972.z / _3309.z));
            float _3332 = (_807._m57 / 100.0) * 16.0;
            vec2 _3337 = _3320 * _3332;
            float _3341 = TEXTURE_LOD(SAMPLER_2D(_3157, _3159), vec4(_3337, 0.0, 0.0).xy, vec4(_3337, 0.0, 0.0).w).x;
            vec4 _3357 = _807._m11;
            _1014._m21 += (_3357.xyz * (((((1.0 - _3304) * (_3341 - 1.0)) * _3313) * _2975) * _3357.w));
            _1014._m25 = 1.0 + ((_3304 * (_3341 - 1.0)) * _2975);
        }
    }
    _1014._m14 = normalize(vec3(_807._m35, _807._m36, _807._m37) - _1014._m15);
    vec3 _3399 = vec3(0.0);
    vec3 _3400 = vec3(0.0);
    vec3 _3401 = vec3(0.0);
    vec3 _3402 = vec3(0.0);
    vec3 _3403 = vec3(0.0);
    vec4 _3404 = _1014._m29;
    vec4 _3407 = _1014._m30;
    vec4 _3410 = _1014._m31;
    _3400 = vec3(_3404.x, _3404.y, _3404.z);
    _3401 = vec3(_3404.w, _3407.x, _3407.y);
    _3402 = vec3(_3407.z, _3407.w, _3410.x);
    _3403 = vec3(_3410.y, _3410.z, _3410.w);
    vec3 _3441 = ((_3400 - (_3401 * _1014._m6.y)) + (_3402 * _1014._m6.z)) - (_3403 * _1014._m6.x);
    float _3465 = _1150._m50 * _807._m59;
    _3399 += (max(vec3(0.0), _3441 * _10(_3465)) * _1014._m0);
    vec3 _3474 = vec3(0.0);
    vec3 _3475 = vec3(0.0);
    vec3 _3476 = vec3(0.0);
    vec3 _3477 = vec3(0.0);
    vec3 _3478 = vec3(0.0);
    vec4 _3479 = _1014._m29;
    vec4 _3482 = _1014._m30;
    vec4 _3485 = _1014._m31;
    _3475 = vec3(_3479.x, _3479.y, _3479.z);
    _3476 = vec3(_3479.w, _3482.x, _3482.y);
    _3477 = vec3(_3482.z, _3482.w, _3485.x);
    _3478 = vec3(_3485.y, _3485.z, _3485.w);
    vec3 _3516 = ((_3475 - (_3476 * _1014._m8.y)) + (_3477 * _1014._m8.z)) - (_3478 * _1014._m8.x);
    float _3539 = _1150._m50 * _807._m59;
    _3474 += (max(vec3(0.0), _3516 * _10(_3539)) * _1014._m0);
    uint _3550 = _1014._m4;
    _3399 = mix(_3399, _3474, vec3(_92(_3550).w));
    _1014._m21 += _3399;
    bool _3562 = true;
    _3562 = (((_807._m61 & 2u) != 0u) == true) ? false : true;
    if (true && (_3562 == true))
    {
        uint _3574 = _3578._m0[_2855 * 64u];
        uint _3585 = _3574 & 255u;
        uint _3589 = _3578._m0[_2889 * 64u];
        uint _3594 = _3589 & 255u;
        uint _3602;
        uint _3604;
        uint _3606;
        if (_3585 < _3594)
        {
            _3602 = _3585;
            _3604 = _3574;
            _3606 = _2855;
        }
        else
        {
            _3602 = _3594;
            _3604 = _3589;
            _3606 = _2889;
        }
        float _3612 = _1014._m47;
        float _3621 = dot(_1014._m14, _1014._m6);
        float _3615 = _10(_3621);
        float _3623 = _3615;
        float _3625 = _1014._m3;
        vec3 _3628 = _1014._m2;
        _1014._m24 = (_118(_3623, _3625, _3628) * _1014._m11) * _1014._m39;
        uint _3639 = 1u;
        _3670 _3672;
        while (_3639 <= _3602)
        {
            uint _3648 = (_3606 * 64u) + _3639;
            uint _3653 = _3578._m0[_3648];
            uint _3657 = _3653;
            if (_3657 >= _3653)
            {
                _3639++;
            }
            float _3666 = 0.0039215688593685626983642578125;
            int _3668 = 4;
            int _3669 = 4;
            _3672._m0 = _3677._m0[(uint(_3668) * _3657) + 0u].xyz;
            float _3692 = _3677._m0[(uint(_3668) * _3657) + 0u].w;
            _3672._m1 = _32(_3692);
            _3672._m2 = _3677._m0[(uint(_3668) * _3657) + 1u].xyz;
            _3672._m3 = _3677._m0[(uint(_3668) * _3657) + 1u].w;
            _3672._m4 = _3677._m0[(uint(_3668) * _3657) + 2u];
            float _3727 = _3677._m0[(uint(_3668) * _3657) + 3u].x;
            _3672._m8 = _32(_3727);
            float _3737 = _3677._m0[(uint(_3668) * _3657) + 3u].y;
            _3672._m9 = _32(_3737);
            _3672._m10 = _3677._m0[(uint(_3668) * _3657) + 3u].z;
            _3672._m5 = _3753._m0[(uint(_3669) * _3657) + 0u];
            _3672._m6 = _3753._m0[(uint(_3669) * _3657) + 1u];
            _3672._m7 = _3753._m0[(uint(_3669) * _3657) + 2u];
            _3672._m12 = _3753._m0[(uint(_3669) * _3657) + 3u].xyz;
            _3672._m13 = _3753._m0[(uint(_3669) * _3657) + 3u].w;
            vec3 _3795 = vec3(dot(_1014._m15, _3672._m5.xyz) + _3672._m5.w, dot(_1014._m15, _3672._m6.xyz) + _3672._m6.w, dot(_1014._m15, _3672._m4.xyz) + _3672._m4.w);
            float _3824 = _3795.x;
            float _3827 = _3795.y;
            float _3830 = _3795.z;
            bool _3835 = _43(_3824, _3827, _3830) <= _3666;
            bool _3852;
            if (!_3835)
            {
                float _3839 = _3795.x;
                float _3842 = _3795.y;
                float _3845 = _3795.z;
                _3852 = _38(_3839, _3842, _3845) >= (1.0 - _3666);
            }
            else
            {
                _3852 = _3835;
            }
            if (_3852)
            {
                continue;
            }
            uint _3856 = _3672._m1;
            vec3 _3859 = _3672._m0;
            float _3862 = float(bitfieldExtract(_3672._m8, 20, 12));
            float _3867 = 0.800000011920928955078125;
            vec3 _3868 = (_3795 * 2.0) - vec3(1.0);
            vec3 _3873 = _3868;
            vec3 _3872 = _52(_3873);
            vec3 _3876 = _3868 * sqrt(((vec3(1.0) - (_3872.yzx * 0.5)) - (_3872.zxy * 0.5)) + ((_3872.yzx * _3872.zxy) / vec3(3.0)));
            float _3908 = 1.0 - ((length(_3876) - _3867) / ((1.0 - _3867) + 9.9999999747524270787835121154785e-07));
            float _3897 = _10(_3908);
            _3897 *= _3897;
            _3897 *= _3612;
            float _3916 = _3672._m7.w;
            _3897 *= _3916;
            _3612 *= (1.0 - _3897);
            vec3 _3926 = _3672._m12;
            float _3929 = _3672._m13;
            float _3934 = _3897;
            vec3 _3932 = _3926 * (_10(_3934) * _3929);
            vec3 _3940 = _3672._m2;
            vec3 _3943 = _3672._m7.xyz;
            vec3 _3947 = vec3(0.0);
            vec3 _3948 = reflect(-_1014._m14, _1014._m6);
            vec3 _3955 = (_3943 - _1014._m15) / _3948;
            vec3 _3962 = (_3940 - _1014._m15) / _3948;
            vec3 _3969 = max(_3955, _3962);
            float _3974 = _3969.x;
            float _3977 = _3969.y;
            float _3980 = _3969.z;
            float _3973 = _43(_3974, _3977, _3980);
            vec3 _3984 = _1014._m15 + (_3948 * _3973);
            vec3 _3991 = _3984 - _3859;
            float _3995 = 6.0;
            float _3997 = _3995 - (_3995 * _1014._m3);
            _3947 = textureLod(samplerCubeArray(_4006, _4008), vec4(_3991, _3862), _3997).xyz;
            _1014._m21 += ((_3947 * _3932) * _1014._m24);
            if (_3612 <= (_3666 * 4.0))
            {
                break;
            }
        }
    }
    uint _4038 = _4042._m0[_2855 * 64u];
    uint _4047 = _4038 & 255u;
    uint _4050 = _4042._m0[_2889 * 64u];
    uint _4055 = _4050 & 255u;
    uint _4063;
    uint _4065;
    uint _4067;
    if (_4047 < _4055)
    {
        _4063 = _4047;
        _4065 = _4038;
        _4067 = _2855;
    }
    else
    {
        _4063 = _4055;
        _4065 = _4050;
        _4067 = _2889;
    }
    uint _4073 = 1u;
    _3670 _4102;
    vec3 _4229;
    float _4350;
    vec2 _4418;
    _4616 _4618;
    _4616 _4765;
    while (_4073 <= _4063)
    {
        uint _4082 = (_4067 * 64u) + _4073;
        uint _4087 = _4042._m0[_4082];
        uint _4091 = _4087;
        if (_4091 >= _4087)
        {
            _4073++;
        }
        int _4100 = 4;
        int _4101 = 4;
        _4102._m0 = _3677._m0[(uint(_4100) * _4091) + 0u].xyz;
        float _4117 = _3677._m0[(uint(_4100) * _4091) + 0u].w;
        _4102._m1 = _32(_4117);
        _4102._m2 = _3677._m0[(uint(_4100) * _4091) + 1u].xyz;
        _4102._m3 = _3677._m0[(uint(_4100) * _4091) + 1u].w;
        _4102._m4 = _3677._m0[(uint(_4100) * _4091) + 2u];
        float _4152 = _3677._m0[(uint(_4100) * _4091) + 3u].x;
        _4102._m8 = _32(_4152);
        float _4162 = _3677._m0[(uint(_4100) * _4091) + 3u].y;
        _4102._m9 = _32(_4162);
        _4102._m10 = _3677._m0[(uint(_4100) * _4091) + 3u].z;
        _4102._m5 = _3753._m0[(uint(_4101) * _4091) + 0u];
        _4102._m6 = _3753._m0[(uint(_4101) * _4091) + 1u];
        _4102._m7 = _3753._m0[(uint(_4101) * _4091) + 2u];
        _4102._m12 = _3753._m0[(uint(_4101) * _4091) + 3u].xyz;
        _4102._m13 = _3753._m0[(uint(_4101) * _4091) + 3u].w;
        float _4216 = 0.0;
        uint _4217 = _4102._m1;
        vec3 _4220 = _4102._m0;
        vec3 _4223 = _4220;
        if ((_4217 & 7u) == 2u)
        {
            _4229 = _4223;
        }
        else
        {
            _4229 = normalize(_4220 - _1014._m15);
        }
        vec3 _4225 = _4229;
        uint _4240 = uint(((_2899 & 3u) != 0u) ? 16 : 0);
        _4240 |= 32u;
        if ((_4217 & _4240) != 0u)
        {
            continue;
        }
        vec3 _4255 = vec3(dot(_1014._m15, _4102._m5.xyz) + _4102._m5.w, dot(_1014._m15, _4102._m6.xyz) + _4102._m6.w, dot(_1014._m15, _4102._m7.xyz) + _4102._m7.w);
        vec2 _4289 = _4255.xy / vec2(_4255.z);
        _4255 = vec3(_4289.x, _4289.y, _4255.z);
        _4255.z = dot(_1014._m15, _4102._m4.xyz) + _4102._m4.w;
        float _4302 = _4255.x;
        float _4305 = _4255.y;
        float _4308 = _4255.z;
        bool _4313 = _43(_4302, _4305, _4308) <= _4216;
        bool _4330;
        if (!_4313)
        {
            float _4317 = _4255.x;
            float _4320 = _4255.y;
            float _4323 = _4255.z;
            _4330 = _38(_4317, _4320, _4323) >= (1.0 - _4216);
        }
        else
        {
            _4330 = _4313;
        }
        if (_4330)
        {
            continue;
        }
        vec3 _4334 = vec3(1.0);
        uint _4335 = _4217 & 7u;
        vec3 _4338 = _4102._m0 - _1014._m15;
        float _4344 = dot(_4338, _4338);
        if (_4335 != 2u)
        {
            _4350 = 1.0 / (1.0 + _4344);
        }
        else
        {
            _4350 = _1014._m25;
        }
        _4334 = vec3(_4350);
        if (_4335 == 0u)
        {
            float _4370 = _4344 * _4102._m3;
            float _4373 = 1.0 - _55(_4370);
            float _4375 = _10(_4373);
            float _4365 = _55(_4375);
            _4334 *= _4365;
        }
        else
        {
            if (_4335 == 4u)
            {
                float _4391 = length((_4255.xy - vec2(0.5)) * 2.0);
                float _4385 = _10(_4391);
                float _4393 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_4385 * 7.80000019073486328125))));
                _4334 *= _4393;
            }
            else
            {
                if ((_4335 == 1u) || (_4335 == 2u))
                {
                    if (_4335 == 2u)
                    {
                        _4418 = fract((_4255.xy * _807._m13.xy) + _807._m13.zw);
                    }
                    else
                    {
                        _4418 = _4255.xy;
                    }
                    vec2 _4415 = _4418;
                    vec3 _4436 = vec3(0.0);
                    uint _4437 = bitfieldExtract(_4102._m8, 0, 20);
                    uint _4441 = _4437;
                    uint _4445 = _4441 + 0u;
                    vec3 _4461 = textureLod(sampler2D(_1419[nonuniformEXT(_4445)], _1299), vec4(_4415, 0.0, 0.0).xy, vec4(_4415, 0.0, 0.0).w).xyz;
                    _4436 = _52(_4461);
                    _4334 *= _4436;
                }
            }
        }
        float _4467 = float((_4217 >> uint(8)) & 255u) / 255.0;
        if ((_4335 == 0u) || (_4335 == 2u))
        {
            vec3 _4480 = abs((_4255 * 2.0) - vec3(1.0));
            float _4486 = _4480.x;
            float _4489 = _4480.y;
            float _4492 = _4480.z;
            float _4497 = 1.0 - _38(_4486, _4489, _4492);
            float _4502 = _10(_4497) / (9.9999999392252902907785028219223e-09 + _4467);
            float _4485 = _10(_4502);
            _4334 *= ((_4485 * _4485) * (3.0 - (2.0 * _4485)));
        }
        else
        {
            if ((_4335 == 1u) || (_4335 == 4u))
            {
                float _4522 = _4255.z;
                float _4526 = _55(_4522);
                float _4529 = 1.0 - _55(_4526);
                float _4531 = _10(_4529);
                float _4536 = _55(_4531) / (9.9999999392252902907785028219223e-09 + _4467);
                float _4521 = _10(_4536);
                _4334 *= _4521;
            }
        }
        float _4541 = _4334.x;
        float _4544 = _4334.y;
        float _4547 = _4334.z;
        if (_38(_4541, _4544, _4547) <= _4216)
        {
            continue;
        }
        float _4556 = 1.0;
        if ((_4217 & 8u) != 0u)
        {
            float _4563 = 0.00200000009499490261077880859375;
            vec3 _4565 = _1014._m15 + (_1014._m6 * _4563);
            uint _4573 = 0u;
            if ((_4217 & 7u) == 0u)
            {
                vec3 _4579 = _4565 - _4102._m2;
                float _4584 = _4579.x;
                float _4587 = _4579.y;
                float _4590 = _4579.z;
                _4573 = _49(_4584, _4587, _4590);
            }
            else
            {
                if ((_4217 & 7u) == 2u)
                {
                    float _4600 = 0.0;
                    uint _4601 = uint((_807._m14.w > 0.0) ? 3 : 4);
                    for (; _4573 < _4601; _4573++)
                    {
                        int _4615 = 5;
                        _4618._m0 = _4623._m0[(uint(_4615) * ((_4217 >> uint(22)) + _4573)) + 0u];
                        _4618._m1 = _4623._m0[(uint(_4615) * ((_4217 >> uint(22)) + _4573)) + 1u];
                        _4618._m2 = _4623._m0[(uint(_4615) * ((_4217 >> uint(22)) + _4573)) + 2u];
                        _4618._m3 = _4623._m0[(uint(_4615) * ((_4217 >> uint(22)) + _4573)) + 3u];
                        _4618._m4 = _4623._m0[(uint(_4615) * ((_4217 >> uint(22)) + _4573)) + 4u];
                        vec2 _4679 = vec2(dot(_4565, _4618._m0.xyz) + _4618._m0.w, dot(_4565, _4618._m1.xyz) + _4618._m1.w);
                        _4679 = abs((_4679 * 2.0) - vec2(1.0));
                        bool _4705 = _4679.x < 0.9900000095367431640625;
                        bool _4711;
                        if (_4705)
                        {
                            _4711 = _4679.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _4711 = _4705;
                        }
                        if (_4711)
                        {
                            _4600 = (1.0 - max(_4679.x, _4679.y)) * _807._m15.w;
                            break;
                        }
                    }
                    _1014._m36 = int(_4573);
                    _4573 = min((_4601 - 1u), _4573);
                    if (_807._m14.w > 0.0)
                    {
                        uint _4738 = uint(_1014._m17.x) ^ (uint(_1014._m17.y) << uint(1));
                        _4738 ^= uint(_807._m16.x);
                        _4573 += uint(int(((float(_4738 & 3u) * 0.25) + 0.125) > _4600));
                    }
                }
            }
            int _4764 = 5;
            _4765._m0 = _4623._m0[(uint(_4764) * ((_4217 >> uint(22)) + _4573)) + 0u];
            _4765._m1 = _4623._m0[(uint(_4764) * ((_4217 >> uint(22)) + _4573)) + 1u];
            _4765._m2 = _4623._m0[(uint(_4764) * ((_4217 >> uint(22)) + _4573)) + 2u];
            _4765._m3 = _4623._m0[(uint(_4764) * ((_4217 >> uint(22)) + _4573)) + 3u];
            _4765._m4 = _4623._m0[(uint(_4764) * ((_4217 >> uint(22)) + _4573)) + 4u];
            vec4 _4821 = vec4((_4565.x * _4765._m0.x) + ((_4565.y * _4765._m0.y) + ((_4565.z * _4765._m0.z) + _4765._m0.w)), (_4565.x * _4765._m1.x) + ((_4565.y * _4765._m1.y) + ((_4565.z * _4765._m1.z) + _4765._m1.w)), (_4565.x * _4765._m2.x) + ((_4565.y * _4765._m2.y) + ((_4565.z * _4765._m2.z) + _4765._m2.w)), (_4565.x * _4765._m3.x) + ((_4565.y * _4765._m3.y) + ((_4565.z * _4765._m3.z) + _4765._m3.w)));
            vec3 _4908 = _4821.xyz / vec3(_4821.w);
            _4821 = vec4(_4908.x, _4908.y, _4908.z, _4821.w);
            bool _4916 = min(_4821.x, _4821.y) > 0.0;
            bool _4925;
            if (_4916)
            {
                _4925 = max(_4821.x, _4821.y) < 1.0;
            }
            else
            {
                _4925 = _4916;
            }
            if (_4925)
            {
                vec2 _4937 = (_4821.xy * _4765._m4.xy) + _4765._m4.zw;
                _4821 = vec4(_4937.x, _4937.y, _4821.z, _4821.w);
                if (false)
                {
                    _4556 = textureLod(sampler2DShadow(_4944, _4946), vec3(_4821.xyz.xy, _4821.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4955 = (_4821.xy * _807._m17.xy) + vec2(0.5);
                    vec2 _4964 = floor(_4955);
                    vec2 _4967 = _4955 - _4964;
                    _4964 -= vec2(0.5);
                    vec2 _4974 = vec2(4.0) - (_4967 * 3.0);
                    vec2 _4979 = vec2(7.0);
                    vec2 _4981 = vec2(1.0) + (_4967 * 3.0);
                    vec2 _4986 = (_4964 + (((vec2(3.0) - (_4967 * 2.0)) / _4974) - vec2(2.0))) * _807._m17.zw;
                    vec2 _5001 = (_4964 + ((vec2(3.0) + _4967) / _4979)) * _807._m17.zw;
                    vec2 _5013 = (_4964 + ((_4967 / _4981) + vec2(2.0))) * _807._m17.zw;
                    vec3 _5039 = vec3(_4986.x, _4986.y, _4821.z);
                    _4556 = (_4974.x * _4974.y) * textureLod(sampler2DShadow(_4944, _4946), vec3(_5039.xy, _5039.z), 0.0);
                    vec3 _5057 = vec3(_5001.x, _4986.y, _4821.z);
                    _4556 += ((_4979.x * _4974.y) * textureLod(sampler2DShadow(_4944, _4946), vec3(_5057.xy, _5057.z), 0.0));
                    vec3 _5077 = vec3(_5013.x, _4986.y, _4821.z);
                    _4556 += ((_4981.x * _4974.y) * textureLod(sampler2DShadow(_4944, _4946), vec3(_5077.xy, _5077.z), 0.0));
                    vec3 _5097 = vec3(_4986.x, _5001.y, _4821.z);
                    _4556 += ((_4974.x * _4979.y) * textureLod(sampler2DShadow(_4944, _4946), vec3(_5097.xy, _5097.z), 0.0));
                    vec3 _5117 = vec3(_5001.x, _5001.y, _4821.z);
                    _4556 += ((_4979.x * _4979.y) * textureLod(sampler2DShadow(_4944, _4946), vec3(_5117.xy, _5117.z), 0.0));
                    vec3 _5137 = vec3(_5013.x, _5001.y, _4821.z);
                    _4556 += ((_4981.x * _4979.y) * textureLod(sampler2DShadow(_4944, _4946), vec3(_5137.xy, _5137.z), 0.0));
                    vec3 _5157 = vec3(_4986.x, _5013.y, _4821.z);
                    _4556 += ((_4974.x * _4981.y) * textureLod(sampler2DShadow(_4944, _4946), vec3(_5157.xy, _5157.z), 0.0));
                    vec3 _5177 = vec3(_5001.x, _5013.y, _4821.z);
                    _4556 += ((_4979.x * _4981.y) * textureLod(sampler2DShadow(_4944, _4946), vec3(_5177.xy, _5177.z), 0.0));
                    vec3 _5197 = vec3(_5013.x, _5013.y, _4821.z);
                    _4556 += ((_4981.x * _4981.y) * textureLod(sampler2DShadow(_4944, _4946), vec3(_5197.xy, _5197.z), 0.0));
                    _4556 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _4556 = float((_4217 & 7u) == 2u);
                if ((_4217 & 7u) == 2u)
                {
                    _1014._m36 = -1;
                }
            }
            float _5217 = float((_4217 >> uint(16)) & 63u) / 63.0;
            float _5231 = ((_4556 * _5217) + 1.0) - _5217;
            _4556 = _10(_5231);
            if ((_807._m60 > 0.0) && (_4556 > 0.0))
            {
                vec4 _5241 = vec4(_1014._m17.xy * _807._m6.xy, _1014._m17.z, 1.0);
                float _5254 = _5241.z;
                bool _5257 = false;
                float _5258 = _138(_5254, _5257);
                _5241.z = _5258;
                vec3 _5295 = _1014._m15 + (_4225 * 0.100000001490116119384765625);
                mat4 _5296 = mat4(vec4(_807._m18), vec4(_807._m19), vec4(_807._m20), vec4(_807._m21));
                vec4 _5260 = _62(_5295, _5296);
                vec3 _5303 = _5260.xyz / vec3(_5260.w);
                _5260 = vec4(_5303.x, _5303.y, _5303.z, _5260.w);
                float _5306 = _5260.z;
                bool _5309 = false;
                float _5310 = _138(_5306, _5309);
                _5260.z = _5310;
                int _5312 = 4;
                vec3 _5313 = vec3(_5260.xyz - _5241.xyz) / vec3(float(_5312));
                float _5327 = 0.100000001490116119384765625;
                float _5328 = 0.001000000047497451305389404296875 * _5241.z;
                uvec2 _5341 = uvec2(_1014._m17.xy);
                uint _5342 = uint(_807._m22.w);
                float _5333 = _165(_5341, _5342) - 0.5;
                vec3 _5345 = _5241.xyz + (_5313 * _5333);
                for (int _5352 = 0; _5352 < _5312; _5352++)
                {
                    _5345 += _5313;
                    float _5364 = 1.0 - TEXTURE_LOD(SAMPLER_2D(_5365, _5367), vec4(_5345.xy, 0.0, 0.0).xy, vec4(_5345.xy, 0.0, 0.0).w).x;
                    float _5386 = _5364;
                    bool _5388 = false;
                    float _5389 = _138(_5386, _5388);
                    float _5385 = _5389 + _5328;
                    bool _5396 = (_5345.z - _5385) > 0.001000000047497451305389404296875;
                    bool _5405;
                    if (_5396)
                    {
                        _5405 = (_5345.z - _5385) <= _5327;
                    }
                    else
                    {
                        _5405 = _5396;
                    }
                    if (_5405)
                    {
                        uint _5409 = _1014._m4;
                        vec3 _5408 = _92(_5409).xyz;
                        //_4556 *= dot(_5408, vec3(0.333000004291534423828125));
                        break;
                    }
                }
            }
        }
        if (_4556 <= _4216)
        {
            continue;
        }
        vec3 _5429 = (_4102._m12 * _4556) * _4334;
        float _5436 = _4102._m13;
        vec3 _5439 = _5429;
        float _5446 = dot(_1014._m6, _4225);
        float _5441 = _10(_5446);
        float _5448 = 1.0;
        vec3 _5450 = _1014._m6;
        vec3 _5453 = _1014._m14;
        vec3 _5456 = _4225;
        vec3 _5458 = _1014._m2;
        float _5461 = _1014._m3;
        vec3 _5449 = _105(_5450, _5453, _5456, _5458, _5461);
        if (subgroupAll(_1138._m25 > 0.0))
        {
            vec3 _5472 = _1014._m6;
            vec3 _5475 = _1014._m14;
            vec3 _5478 = _4225;
            vec3 _5480 = _1014._m2;
            float _5483 = _1014._m3;
            vec3 _5471 = _112(_5472, _5475, _5478, _5480, _5483);
            _5449 = mix(_5449, _5471, vec3(_1014._m46));
        }
        _1014._m21 += ((((_5449 * _5436) * _5439) * _5441) * _5448);
        vec3 _5506 = _5439;
        uint _5509 = _1014._m4;
        vec4 _5508 = _92(_5509);
        vec3 _5513 = _5508.xyz;
        float _5521 = dot(_1014._m8, _4225);
        float _5516 = _10(_5521);
        vec3 _5523 = vec3(mix(_5441, _5516, _1138._m45), mix(_5441, _5516, _1138._m44), mix(_5441, _5516, _1138._m43));
        float _5554 = dot(_1014._m14, -_4225);
        float _5556 = _10(_5554);
        float _5557 = _1138._m13.w;
        vec3 _5564 = ((_1138._m13.xyz + vec3(_1014._m5)) * _77(_5556, _5557)) * _5513;
        _5523 += _16(_5564);
        float _5568 = _5508.w;
        _5523 = mix(vec3(_5441), _5523, vec3(_5568));
        _1014._m21 += ((_5506 * _5523) * _1014._m0);
    }
    _1014._m21 *= _1014._m11;
    vec3 _5593 = vec3(_1024, _1026, _1028);
    float _5598 = _5599;
    float _5601 = _5602;
    float _5604 = _5605;
    float _5607 = _5608;
    if (_1150._m52 < 1.0)
    {
        if (vec3(_1150._m60, _1150._m61, _1150._m62).x > 0.0)
        {
            vec2 _5627 = abs(vec2(1.0) / _807._m6.xy);
            vec2 _5634 = ((vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * 1.5) * _807._m6.xy) * (_5627 / vec2(32.0));
            vec4 _5657 = TEXTURE_LOD(SAMPLER_2D(_5658, _1424), vec4(_5634 * vec2(0.699999988079071044921875), 0.0, 0.0).xy, vec4(_5634 * vec2(0.699999988079071044921875), 0.0, 0.0).w);
            float _5676 = 1.0 - dot(_1014._m6, normalize(-_5593));
            float _5684 = 1.0;
            float _5685 = vec3(_1150._m54, _1150._m55, _1150._m56).x;
            if (vec3(_1150._m60, _1150._m61, _1150._m62).y >= vec3(_1150._m54, _1150._m55, _1150._m56).z)
            {
                _5685 = vec3(_1150._m54, _1150._m55, _1150._m56).y;
            }
            float _5721 = mix(vec3(_1150._m57, _1150._m58, _1150._m59).x, vec3(_1150._m57, _1150._m58, _1150._m59).y, vec3(_1150._m60, _1150._m61, _1150._m62).y);
            float _5747 = _5593.z * _5721;
            float _5752 = (sin(_5747 + (_807._m53 * _5685)) * _5684) + _5684;
            float _5764 = vec3(_1150._m57, _1150._m58, _1150._m59).z;
            _5752 = pow(_5752, _5764);
            _5752 *= _5676;
            float _5779 = pow(_5676, 4.0);
            float _5789 = (_5657.x * _5676) + _5779;
            vec3 _5782 = (_1150._m10.xyz * _10(_5789)) * 2.0;
            _5782 /= _807._m23.xyz;
            vec3 _5801 = _5782 * _5752;
            _1014._m21 += max(vec3(0.0), _5801);
        }
        if (_1150._m16.w > 0.0)
        {
            vec2 _5816 = abs(vec2(1.0) / _807._m6.xy);
            vec2 _5822 = ((vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * 1.5) * _807._m6.xy) * (_5816 / vec2(32.0));
            vec4 _5843 = TEXTURE_LOD(SAMPLER_2D(_5658, _1424), vec4(_5822 * vec2(0.699999988079071044921875), 0.0, 0.0).xy, vec4(_5822 * vec2(0.699999988079071044921875), 0.0, 0.0).w);
            float _5860 = 1.0 - dot(_1014._m6, normalize(-_5593));
            float _5868 = pow(_5860, 4.0);
            float _5878 = (_5843.x * _5860) + _5868;
            vec3 _5871 = (_1150._m16.xyz * _10(_5878)) * 6.0;
            _5871 /= _807._m23.xyz;
            _1014._m21 += (max(vec3(0.0), _5871) * _5598);
        }
        bool _5900 = _1138._m28 > 0.0;
        bool _5906;
        if (_5900)
        {
            _5906 = _1150._m36 > 0.0;
        }
        else
        {
            _5906 = _5900;
        }
        if (_5906)
        {
            float _5909 = SAMPLE_TEXTURE(SAMPLER_2D(_2466, _1424), vec2(_5604, _5604) + vec2(_807._m53 * 1.0)).x;
            _5909 *= (_5909 * _5909);
            vec3 _5928 = mix(vec3(1.0, 0.5, 0.00999999977648258209228515625), vec3(1.0, 0.0500000007450580596923828125, 0.00999999977648258209228515625), vec3(_5604));
            vec3 _5935 = mix(vec3(0.01200000010430812835693359375, 0.100000001490116119384765625, 0.60000002384185791015625), vec3(0.0, 0.0, 0.60000002384185791015625), vec3(_5604));
            vec3 _5949;
            if (((_1138._m65 & 8u) != 0u) == true)
            {
                _5949 = _5935;
            }
            else
            {
                _5949 = _5928;
            }
            float _5953 = 1.0 - dot(_1014._m6, normalize(-_5593));
            float _5961 = pow(_5953, 4.0);
            float _5971 = (1.0 * (_5953 * _5953)) + _5961;
            vec3 _5964 = (((_5949 * _10(_5971)) * _5601) * (_5909 * 10.0)) * 3.0;
            _5964 *= mix(1.0, 0.0, _1150._m16.w);
            _1014._m21 += (_5964 * _1150._m36);
        }
        if (_1150._m11.w > 0.0)
        {
            float _6000 = dot(_1014._m6, normalize(-_5593));
            _6000 *= (_6000 * _6000);
            vec3 _6012 = vec3(_6000) * _1150._m11.xyz;
            _1014._m21 += _6012;
        }
        vec2 _6024 = vec2(_1017, _1019);
        float _6028 = texture(sampler2D(_1419[_1138._m62], _1424), _6024).x;
        float _6038 = _6039;
        float _6049 = 1.0 - _6038;
        vec3 _6041 = ((mix(vec3(0.5, 0.001000000047497451305389404296875, 0.0), vec3(1.0, 0.100000001490116119384765625, 0.0), vec3(_6028)) * _10(_6049)) * _6028) * _1150._m67;
        vec4 _6058 = vec4(0.0);
        _6058 = texture(sampler2D(_1419[_1138._m24], _1424), _6024 * _1138._m14.xy);
        float _6071 = _2318;
        vec3 _6073 = ((mix(vec3(0.5, 0.001000000047497451305389404296875, 0.0), vec3(1.0, 0.3499999940395355224609375, 0.0), vec3(_6058.w)) * _6058.w) * 20.0) * _6071;
        float _6087 = _6088;
        float _6093 = (_6087 * 10.0) - 3.0;
        _6073 += (((((mix(vec3(0.5, 0.001000000047497451305389404296875, 0.0), vec3(1.0, 0.3499999940395355224609375, 0.0), vec3((_6058.z * _6058.z) * _6058.z)) * _10(_6093)) * _6058.z) * _6058.z) * _6058.z) * 12.0);
        _1014._m21 += (_6041 + _6073);
        if (_1150._m44 > 0.0)
        {
            vec3 _6131 = texture(sampler2D(_1419[_1138._m38], _1424), _1014._m16.zw).xyz;
            vec3 _6143 = mix(_1150._m0.xyz, _1150._m1.xyz, _6131);
            _1014._m21 += ((_6131 * _6143) * mix(0.0, 10.0, _1150._m44));
        }
        if (_1150._m8.w > 0.0)
        {
            float _6168 = 1.0 - dot(_1014._m6, _1014._m14);
            _6168 = pow(_6168, 42.0);
            vec3 _6178 = mix(vec3(1.0), vec3(0.0), vec3(_1014._m7.z));
            _6178 *= (_6178 * _6178);
            vec3 _6188 = vec3(_6168);
            _6188 = clamp(_6188, vec3(0.0), vec3(0.100000001490116119384765625));
            _1014._m21 += ((_6178 + (_6188 * vec3(15.0))) * _1150._m8.xyz);
        }
        if (_1150._m4.w > 0.0)
        {
            float _6214 = 1.0 - (0.85000002384185791015625 * dot(_1014._m6, _1014._m14));
            float _6222 = _1150._m4.w * _6214;
            _1014._m21 = mix(_1014._m21, _1150._m4.xyz, vec3(_6222));
        }
    }
    _1012 = _1014._m6.x;
    _1013 = dot(_1014._m6, normalize(-_5593));
    _1013 = 1.0 - _1013;
    _1013 *= _1013;
    _1014._m21 = mix(_1014._m21, _1150._m9.xyz * 10.0, vec3(_5607));
    _6260 = vec4(_1014._m21, 0.0);
    if (((_807._m61 & 2u) != 0u) == true)
    {
        vec3 _6275 = _1014._m6;
        bool _6278 = false;
        vec2 _6279 = _173(_6275, _6278);
        _6274 = vec4(_6279, 0.0, 0.0);
        float _6289 = dot(_1014._m14, _1014._m6);
        float _6283 = _10(_6289);
        float _6292 = _6283;
        float _6294 = _1014._m3;
        vec3 _6297 = _1014._m2;
        vec3 _6291 = _118(_6292, _6294, _6297);
        float _6302 = _6291.x;
        float _6306 = _6291.y;
        float _6310 = _6291.z;
        float _6314 = _1014._m3;
        _6301 = vec4(_80(_6302), _80(_6306), _80(_6310), _176(_6314));
    }
    vec2 _6319 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _807._m6.xy;
    if (_1150._m65 < 1.0)
    {
        vec3 _6340 = TEXTURE_LOD(SAMPLER_2D(_6341, _1424), vec4(_6319 + vec2(_1012 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).xy, vec4(_6319 + vec2(_1012 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).w).xyz;
        vec3 _6367 = _6340 * vec3(1.0, 0.25, 0.0);
        _6260 = vec4(_6367.x, _6367.y, _6367.z, _6260.w);
        vec3 _6379 = _6260.xyz + ((vec3(_1013 * _1013) * 10.0) * vec3(1.0, 0.0500000007450580596923828125, 0.0));
        _6260 = vec4(_6379.x, _6379.y, _6379.z, _6260.w);
    }
    float _6382 = _1150._m52;
    if (_6382 > 0.0)
    {
        vec2 _6389 = vec2(_1017, _1019);
        float _6393 = (SAMPLE_TEXTURE(SAMPLER_2D(_2466, _1424), _6389 * _1138._m14.xy).x * 0.5) - 0.100000001490116119384765625;
        if (_6382 > _6393)
        {
            vec3 _6433 = TEXTURE_LOD(SAMPLER_2D(_6341, _1424), vec4(_6319 + vec2(_1012 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).xy, vec4(_6319 + vec2(_1012 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).w).xyz;
            _6260 = vec4(_6433.x, _6433.y, _6433.z, _6260.w);
        }
        else
        {
            if (_6382 > (_6393 - 0.02500000037252902984619140625))
            {
                _6260 = vec4(vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).x, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).y, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).z, _6260.w);
            }
        }
    }
}


