// Geometry
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _108
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _69_71
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    float _m16;
    float _m17;
    float _m18;
    uint _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    uint _m24;
    uint _m25;
    uint _m26;
    uint _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    uint _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    uint _m57;
    float _m58[2];
} _71;

layout(set = 0, binding = 2, std430) restrict readonly buffer _110_112
{
    _108 _m0[];
} _112;

layout(set = 0, binding = 0, std140) uniform _200_202
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    uint _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26[2];
} _202;

layout(set = 0, binding = 1, std140) uniform _225_227
{
    vec4 _m0[64];
} _227;

layout(set = 1, binding = 0, std140) uniform _229_231
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    int _m31;
    uint _m32;
    float _m33[3];
} _231;

layout(push_constant, std430) uniform _114_116
{
    int _m0;
} _116;

layout(location = 0, component = 0) in vec4 _59;
uint _16;
uint _18;
uint _20;
uint _22;
uint _24;
uint _26;
uint _28;
uint _29;
uint _31;
uint _32;
uint _34;
uint _36;
uint _38;
uint _40;
uint _42;
uint _44;
uint _46;
uint _48;
uint _50;

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

void main()
{
    _16 = 2147483648u;
    _18 = 1073741824u;
    _20 = 0u;
    _22 = 268435456u;
    _24 = 536870912u;
    _26 = 805306368u;
    _28 = 1073741824u;
    _29 = 1342177280u;
    _31 = 0u;
    _32 = 16777216u;
    _34 = 33554432u;
    _36 = 50331648u;
    _38 = 67108864u;
    _40 = 83886080u;
    _42 = 100663296u;
    _44 = 117440512u;
    _46 = 134217728u;
    _48 = 150994944u;
    _50 = 167772160u;
    vec4 _57;
    _57 = vec4(_59.xyz.x, _59.xyz.y, _59.xyz.z, _57.w);
    vec3 _66 = vec3(_71._m54, _71._m55, _71._m56);
    vec3 _84 = vec3(_71._m51, _71._m52, _71._m53);
    vec3 _100 = (_57.xyz * _66) + _84;
    _57 = vec4(_100.x, _100.y, _100.z, _57.w);
    _57.w = 1.0;
    vec4 _107 = _112._m0[_116._m0]._m0;
    vec4 _123 = _112._m0[_116._m0]._m1;
    vec4 _129 = _112._m0[_116._m0]._m2;
    vec4 _135 = _112._m0[_116._m0]._m3;
    vec4 _152 = vec4(_57.xyz, 1.0);
    vec4 _153 = _107;
    gl_Position.x = _12(_152, _153);
    vec4 _164 = vec4(_57.xyz, 1.0);
    vec4 _165 = _123;
    gl_Position.y = _12(_164, _165);
    vec4 _175 = vec4(_57.xyz, 1.0);
    vec4 _176 = _129;
    gl_Position.z = _12(_175, _176);
    vec4 _186 = vec4(_57.xyz, 1.0);
    vec4 _187 = _135;
    gl_Position.w = _12(_186, _187);
    bool _193 = false;
    if (_193 == false)
    {
        vec2 _215 = gl_Position.xy + (_202._m3.xy * gl_Position.w);
        gl_Position = vec4(_215.x, _215.y, gl_Position.z, gl_Position.w);
    }
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
}


